﻿using System;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace ConsoleApplication.card
{
    /// <summary>
    /// クレジットカード決済 与信要求サンプル
    /// </summary>
    public class CLI_CardAuthorize
    {
        public virtual void Exec()
        {
            /**
             * 取引ID
             */
            String orderId = "dummy" + System.DateTime.Now.ToString("HHmmssfff");

            /**
             * 同時売上実施有無
             */
            String isWithCapture = "false";

            /**
             * 支払金額
             */
            String amount = "10";

            /**
             * 支払オプション
             */
            String jpo = "10";

            /**
             * トークン
             */
            String token = "0a812412-682c-4dad-8a5d-720caf23bca0";

            // /**
            //  * カード番号
            //  */
            // String cardNumber = "4111-1111-1111-1111";
            // /**
            //  * カード有効期限 MM/YY
            //  */
            // String cardExpire = "12/19";
            // /**
            //  *セキュリティコード
            //  */
            // String securityCode = "1234";

            /**
             * 要求電文パラメータ値の指定
             */
            CardAuthorizeRequestDto requestData = new CardAuthorizeRequestDto();
            requestData.OrderId = orderId;
            requestData.Amount = amount;
            requestData.WithCapture = isWithCapture;
            requestData.Jpo = jpo;
            requestData.Token = token;
            // requestData.CardNumber = cardNumber;
            // requestData.CardExpire = cardExpire;
            // requestData.SecurityCode = securityCode;

            /**
             * 実行と結果表示  
            */
            Transaction tran = new Transaction();
            CardAuthorizeResponseDto responseData = (CardAuthorizeResponseDto)tran.Execute(requestData);

            System.Console.WriteLine("<< REQUEST >>");
            System.Console.WriteLine("Order ID:" + requestData.OrderId);
            System.Console.WriteLine("WithCapture:" + requestData.WithCapture);
            System.Console.WriteLine("Amount:" + requestData.Amount);
            System.Console.WriteLine("JPO:" + requestData.Jpo);
            System.Console.WriteLine("Token:" + requestData.Token);
            // System.Console.WriteLine("Card Number:" + requestData.CardNumber);
            // System.Console.WriteLine("Card Expired Date:" + requestData.CardExpire);
            // System.Console.WriteLine("Security Code:" + requestData.SecurityCode);

            System.Console.WriteLine("<< RESPONSE >>");
            System.Console.WriteLine("MStatus:" + responseData.Mstatus);
            System.Console.WriteLine("Message:"+ responseData.MerrMsg);
            System.Console.WriteLine("Result Code:" + responseData.VResultCode);
            System.Console.WriteLine("Auth Code:" + responseData.ResAuthCode);
            System.Console.WriteLine("Reference Number:" + responseData.ResReturnReferenceNumber);
        }
    }
}
