﻿using System;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace ConsoleApplication.card
{
    /// <summary>
    /// クレジットカード決済 売上要求サンプル
    /// </summary>
    public class CLI_CardCapture
    {
        public virtual void Exec()
        {
            /**
             * 取引ID
             * 与信完了取引のIDを指定
             */
            String orderId = "";
            /**
             * 支払金額
             * 指定無しの場合全額取消
             */
            String Amount = "5";

            /**
             * 要求電文パラメータ値の指定
             */
            CardCaptureRequestDto requestData = new CardCaptureRequestDto();
            requestData.OrderId = orderId;
            requestData.Amount = Amount;

            /**
             *  実行と結果表示
             */
            Transaction tran = new Transaction();
            CardCaptureResponseDto responseData = (CardCaptureResponseDto)tran.Execute(requestData);

            System.Console.WriteLine("<< REQUEST >>");
            System.Console.WriteLine("Order ID:" + requestData.OrderId);
            System.Console.WriteLine("Amount:" + requestData.Amount);

            System.Console.WriteLine("<< RESPONSE >>");
            System.Console.WriteLine("MStatus:" + responseData.Mstatus);
            System.Console.WriteLine("Message:" + responseData.MerrMsg);
            System.Console.WriteLine("Result Code:" + responseData.VResultCode);
            System.Console.WriteLine("Auth Code:" + responseData.ResAuthCode);
            System.Console.WriteLine("Reference Number:" + responseData.ResReturnReferenceNumber);
        }
    }
}
