﻿using System;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace ConsoleApplication.card
{
    /// <summary>
    /// クレジットカード決済 再与信要求サンプル
    /// </summary>
    public partial class CLI_CardReAuthorize
    {
        public virtual void Exec()
        {
            /**
             * 取引ID
             */
            String orderId = "dummy" + System.DateTime.Now.ToString("HHmmssfff");
            /**
             * 元取引ID
             * 対象とする過去の取引IDを指定
             */
            String originalOrderId = "";
            /**
             * 同時売上実施有無
             */
            String isWithCapture = "true";
            /**
             * 決済金額
             */
            String Amount = "5";
            /**
             * 支払オプション
             */
            String jpo = "10";
            /**
             * セキュリティコード
             */
            String securityCode = "1234";

            /**
             * 要求電文パラメータ値の指定
             */
            CardReAuthorizeRequestDto requestData = new CardReAuthorizeRequestDto();
            requestData.OrderId = orderId;
            requestData.OriginalOrderId = originalOrderId;
            requestData.Amount = Amount;
            requestData.WithCapture = isWithCapture;
            requestData.Jpo = jpo;
            requestData.SecurityCode = securityCode;

            /**
             * 実行と結果表示
             */
            Transaction tran = new Transaction();
            CardReAuthorizeResponseDto responseData = (CardReAuthorizeResponseDto)tran.Execute(requestData);

            System.Console.WriteLine("<< REQUEST >>");
            System.Console.WriteLine("Order ID:" + requestData.OrderId);
            System.Console.WriteLine("WithCapture:" + requestData.WithCapture);
            System.Console.WriteLine("Amount:" + requestData.Amount);
            System.Console.WriteLine("JPO:" + requestData.Jpo);

            System.Console.WriteLine("<< RESPONSE >>");
            System.Console.WriteLine("MStatus:" + responseData.Mstatus);
            System.Console.WriteLine("Message:" + responseData.MerrMsg);
            System.Console.WriteLine("Result Code:" + responseData.VResultCode);
            System.Console.WriteLine("Auth Code:" + responseData.ResAuthCode);
            System.Console.WriteLine("Reference Number:" + responseData.ResReturnReferenceNumber);
        }
    }
}
