﻿using System;
using System.Collections.Generic;
using System.Text;
using jp.veritrans.tercerog.mdk.dto;
using jp.veritrans.tercerog.mdk;

namespace ConsoleApplication.carrier
{
    /// <summary>
    /// キャリア決済(与信)サンプル
    /// </summary>
    class CLI_CarrierAuthorize
    {
        public virtual void Exec()
        {
            /**
             * サービスオプションタイプ 
             * au          : auかんたん決済
             * docomo      : ドコモケータイ払い
             * sb_ktai     : ソフトバンクまとめて支払い(B)
             * sb_matomete : ソフトバンクまとめて支払い(A)
             * s_bikkuri   : S!まとめて払い
             */
            String serviceOptionType = "au";
            /**
             * 取引ID
             */
            String orderId = "dummy" + System.DateTime.Now.ToString("HHmmssfff");
            /**
             * 与信方法
             * ソフトバンクまとめて支払い（A）は与信同時売上のみのため "true" を
             * 指定する必要があります
             */
            String withCapture = "false";
            /**
             * 支払金額
             */
            String amount = "10";
            /**
             * 商品番号
             */
            String itemId = "12345";
            /**
             * 都度継続区分
             * 0 : 都度
             * 1 : 継続
             */
            String accountingType = "0";
            /**
             * 端末種別
             * 0 : PC
             * 1 : スマートフォン
             * 2 : フィーチャーフォン
             */
            String terminalKind = "0";
            /**
             * 商品タイプ
             * 0 : デジタルコンテンツ
             * 1 : 物販
             * 2 : 役務
             */
            String itemType = "0";
            /**
             * OpenID
             */
            String openId = "";

            CarrierAuthorizeRequestDto requestData = new CarrierAuthorizeRequestDto();
            requestData.ServiceOptionType = serviceOptionType;
            requestData.OrderId = orderId;
            requestData.WithCapture = withCapture;
            requestData.Amount = amount;
            requestData.ItemId = itemId;
            requestData.AccountingType = accountingType;
            requestData.TerminalKind = terminalKind;
            requestData.ItemType = itemType;
            requestData.OpenId = openId;

            /**
             * 実行と結果表示  
            */
            Transaction tran = new Transaction();
            CarrierAuthorizeResponseDto responseDate = (CarrierAuthorizeResponseDto)tran.Execute(requestData);

            System.Console.WriteLine("<< REQUEST >>");
            System.Console.WriteLine("Order ID:" + requestData.OrderId);
            System.Console.WriteLine("Service Option Type:" + requestData.ServiceOptionType);
            System.Console.WriteLine("Amount:" + requestData.Amount);
            System.Console.WriteLine("WithCapture:" + requestData.WithCapture);
            System.Console.WriteLine("Accounting Type:" + requestData.AccountingType);
            System.Console.WriteLine("Terminal Kind:" + requestData.TerminalKind);

            System.Console.WriteLine("<< RESPONSE >>");
            System.Console.WriteLine("MStatus:" + responseDate.Mstatus);
            System.Console.WriteLine("Message:" + responseDate.MerrMsg);
            System.Console.WriteLine("Result Code:" + responseDate.VResultCode);
            System.Console.WriteLine("Response Contents:" + responseDate.ResponseContents);
        }
    }
}
