﻿using System;
using System.Collections.Generic;
using System.Text;
using jp.veritrans.tercerog.mdk.dto;
using jp.veritrans.tercerog.mdk;

namespace ConsoleApplication.carrier
{
    /// <summary>
    /// キャリア決済(売上)サンプル
    /// </summary>
    class CLI_CarrierCapture
    {
        public virtual void Exec()
        {
            /**
             * サービスオプションタイプ 
             * au          : auかんたん決済
             * docomo      : ドコモケータイ払い
             * sb_ktai     : ソフトバンクまとめて支払い(B)
             * s_bikkuri   : S!まとめて払い
             */
            String serviceOptionType = "au";
            /**
             * 取引ID
             * 与信完了取引のIDを指定
             */
            String orderId = "dummy1372837947242";
            /**
             * 課金売上月
             * 継続課金(docomo/flets)の場合、指定した年月の売り上げを行います
             * 形式は YYYYMM
             */
            String captureMonth = "";

            CarrierCaptureRequestDto requestData = new CarrierCaptureRequestDto();
            requestData.ServiceOptionType = serviceOptionType;
            requestData.OrderId = orderId;
            requestData.CaptureMonth = captureMonth;

            /**
             * 実行と結果の表示
             */
            Transaction tran = new Transaction();
            CarrierCaptureResponseDto responseDate = (CarrierCaptureResponseDto)tran.Execute(requestData);

            System.Console.WriteLine("<< REQUEST >>");
            System.Console.WriteLine("Order ID:" + requestData.OrderId);
            System.Console.WriteLine("Service Option Type:" + requestData.ServiceOptionType);
            System.Console.WriteLine("Capture Month:" + requestData.CaptureMonth);

            System.Console.WriteLine("<< RESPONSE >>");
            System.Console.WriteLine("MStatus:" + responseDate.Mstatus);
            System.Console.WriteLine("Message:" + responseDate.MerrMsg);
            System.Console.WriteLine("Result Code:" + responseDate.VResultCode);
            System.Console.WriteLine("Capture Date Time:" + responseDate.CaptureDatetime);


        }
    }
}
