﻿using System;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace ConsoleApplication.em
{
    /// <summary>
    /// 電子マネー決済 取消要求サンプル
    /// </summary>
    public partial class CLI_EmCancel
    {
        public virtual void Exec()
        {
            /**
             * 決済方式
             *   
             * モバイルSuicaメール決済　　　　　 : suica-mobile-mail
             * モバイルSuicaアプリ決済 　　　　　: suica-mobile-app
             * Suicaインターネット決済メール連携 : suica-pc-mail
             * Suicaインターネット決済アプリ連携 : suica-pc-app
             * nanaco決済                        : tcc-redirect
             */
            String serviceOptionType = "suica-mobile-mail";

            /**
             * 取引ID
             * 申込時の取引IDを指定
             */
            String orderId = "";
            /**
             * オーダー種別
             */
            String orderKind = "authorize";
            /**
             * 取消通知用メールアドレス
             */
            String cancelMailAddress = "dummy-support@vt-mdk.co.jp";

            /**
             * 要求電文パラメータ値の指定
             */
            EmCancelRequestDto requestData = new EmCancelRequestDto();
            requestData.ServiceOptionType = serviceOptionType;
            requestData.OrderId = orderId;

            if (serviceOptionType != "tcc-redirect")
            {
                requestData.OrderKind = orderKind;
                requestData.CancelMailAddr = cancelMailAddress;
            }

            /**
             * 実行と結果表示
             */
            Transaction tran = new Transaction();
            EmCancelResponseDto responseData = (EmCancelResponseDto)tran.Execute(requestData);

            System.Console.WriteLine("<< REQUEST >>");
            System.Console.WriteLine("ServiceOptionType:" + requestData.ServiceOptionType);
            System.Console.WriteLine("Order ID:" + requestData.OrderId);

            System.Console.WriteLine("<< RESPONSE >>");
            System.Console.WriteLine("MStatus:" + responseData.Mstatus);
            System.Console.WriteLine("Message:" + responseData.MerrMsg);
            System.Console.WriteLine("Result Code:" + responseData.VResultCode);
        }
    }
}
