using System;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace ConsoleApplication.paynowid
{
    /// <summary>
    /// PayNowId(会員退会)処理用サーブレット
    /// </summary>
    public class CLI_PayNowIdAccountDeleteCommand
    {
        /// <summary>
        /// コマンドテスト用メインメソッド
        /// </summary>
        public void Exec()
        {
            // ---------------------------------
            // テスト用リクエスト電文項目設定
            // ---------------------------------
            // 会員ID
            String accountId = "TestAccountId";
            // 退会年月日
            String deleteDate = "20130930";

            // ---------------------------------
            // リクエスト DTO 設定
            // ---------------------------------
            var reqDto = new AccountDeleteRequestDto
                {
                    AccountId = accountId, // 会員IDの設定
                    DeleteDate = deleteDate // 退会年月日
                };

            // ---------------------------------
            // 処理実行と結果表示
            // ---------------------------------

            try
            {
                var tran = new Transaction();
                var resDto = (AccountDeleteResponseDto) tran.Execute(reqDto);

                // リクエストとレスポンスを実行コンソール上で表示する
                Console.WriteLine("*- PayNowId(Delete) -*");

                Console.WriteLine("<< REQUEST >>");
                Console.WriteLine("ServiceType:" + reqDto.ServiceType);
                Console.WriteLine("Account ID:" + accountId);
                Console.WriteLine("Delete Date:" + deleteDate);

                Console.WriteLine("<< RESPONSE >>");
                Console.WriteLine("PayNowId Status:" + resDto.PayNowIdResponse.Status);
                Console.WriteLine("Message:" + resDto.MerrMsg);
                Console.WriteLine("Result Code:" + resDto.VResultCode);
                Console.WriteLine("PayNowId ProcId:" + resDto.PayNowIdResponse.ProcessId);

            }
            catch (Exception ex)
            {
                Console.WriteLine("Exception Occured !");
                Console.WriteLine("Exception Message " + ex.Message);
            }

        }
    }
}