﻿using System;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace ConsoleApplication.saison
{
    /// <summary>
    /// 永久不滅ポイント(永久不滅ウォレット) 取消要求サンプル
    /// </summary>
    public partial class CLI_SaisonCancel
    {
        public virtual void Exec()
        {
            /**
             * 取引ID(キャンセル対象取引IDを設定してください)
             */
            String orderId = "dummy105500266";
            /**
             * カード取消フラグ（0： 永久不滅のみキャンセル、1：永久不滅とカード決済の両方キャンセル）
             */
            String cardCancelFlag = "1";

            /**
             * 要求電文パラメータ値の指定
             */
            SaisonCancelRequestDto requestData = new SaisonCancelRequestDto();
            requestData.OrderId = orderId;
            requestData.CardCancelFlag = cardCancelFlag;

            /**
             * 実行と結果表示
             */
            Transaction tran = new Transaction();
            SaisonCancelResponseDto responseData = (SaisonCancelResponseDto)tran.Execute(requestData);

            System.Console.WriteLine("<< REQUEST >>");
            System.Console.WriteLine("ServiceOptionType:" + requestData.ServiceOptionType);
            System.Console.WriteLine("Order ID:" + requestData.OrderId);

            System.Console.WriteLine("<< RESPONSE >>");
            System.Console.WriteLine("MStatus:" + responseData.Mstatus);
            System.Console.WriteLine("Message:" + responseData.MerrMsg);
            System.Console.WriteLine("Result Code:" + responseData.VResultCode);
        }
    }
}
