﻿using System;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace ConsoleApplication.saison
{
    /// <summary>
    /// 永久不滅ポイント(永久不滅ウォレット) 売上要求サンプル
    /// </summary>
    public partial class CLI_SaisonCapture
    {
        public virtual void Exec()
        {
            /**
             * 取引ID(決済対象取引IDを設定してください)
             */
            String orderId = "dummy1487659547";
            /**
             * 決済金額
             */
            String amount = "100";
            /**
             * 永久不滅ウォレット決済金額
             */
            String wallletAmount = "70";
            /**
             * カード決済金額
             */
            String cardAmount = "30";
            /**
             * トークン
             */
            String token = "0a812412-682c-4dad-8a5d-720caf23bca0";
            /**
             * カード取引ID
             */
            String cardOrderId = "";
            /**
             * カード売上フラグ
             */
            String withCapture = "true";

            /**
             * 要求電文パラメータ値の指定
             */
            SaisonCaptureRequestDto requestData = new SaisonCaptureRequestDto();
            requestData.OrderId = orderId;
            requestData.Amount = amount;
            requestData.WalletAmount = wallletAmount;
            requestData.CardAmount = cardAmount;
            requestData.Token = token;
            requestData.CardOrderId = cardOrderId;
            requestData.WithCapture = withCapture;

            /**
             * 実行と結果表示
             */
            Transaction tran = new Transaction();
            SaisonCaptureResponseDto responseData = (SaisonCaptureResponseDto)tran.Execute(requestData);

            System.Console.WriteLine("<< REQUEST >>");
            System.Console.WriteLine("Order ID:" + requestData.OrderId);
            System.Console.WriteLine("Amount:" + requestData.Amount);
            System.Console.WriteLine("Wallet Amount:" + requestData.WalletAmount);
            System.Console.WriteLine("Card Amount:" + requestData.CardAmount);
            System.Console.WriteLine("Token:" + requestData.Token);
            System.Console.WriteLine("Card Order ID:" + requestData.CardOrderId);
            System.Console.WriteLine("With Capture:" + requestData.WithCapture);

            System.Console.WriteLine("<< RESPONSE >>");
            System.Console.WriteLine("MStatus:" + responseData.Mstatus);
            System.Console.WriteLine("Message:" + responseData.MerrMsg);
            System.Console.WriteLine("Result Code:" + responseData.VResultCode);
            System.Console.WriteLine("ResAuthCode:" + responseData.ResAuthCode);
        }
    }
}
