﻿using System;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace ConsoleApplication.upop
{
    /// <summary>
    /// 銀聯ネット決済(UPOP) 決済要求サンプル
    /// </summary>
    public class CLI_UpopAuthorize
    {
        public virtual void Exec()
        {
            /**
             * 取引ID
             */
            String orderId = "dummy" + System.DateTime.Now.ToString("HHmmssfff");

            /**
             * 金額
             */
            String amount = "10";

            /**
             * 同時売上実施有無
             */
            String isWithCapture = "false";

            /**
             * 決済結果戻り先URL
             */
            String termUrl = "http://localhost/web/upop/AuthorizeResult";

            /**
             * 消費者IPアドレス
             */
            String customerIp = "111.111.111.111";

            /**
             * 要求電文パラメータ値の指定
             */
            UpopAuthorizeRequestDto requestData = new UpopAuthorizeRequestDto();
            requestData.OrderId = orderId;
            requestData.Amount = amount;
            requestData.WithCapture = isWithCapture;
            requestData.TermUrl = termUrl;
            requestData.CustomerIp = customerIp;

            /**
             * 実行と結果表示
            */
            Transaction tran = new Transaction();
            UpopAuthorizeResponseDto responseData = (UpopAuthorizeResponseDto)tran.Execute(requestData);

            System.Console.WriteLine("<< REQUEST >>");
            System.Console.WriteLine("Order ID:" + requestData.OrderId);
            System.Console.WriteLine("Amount:" + requestData.Amount);
            System.Console.WriteLine("With Capture:" + requestData.WithCapture);
            System.Console.WriteLine("Term Url:" + requestData.TermUrl);
            System.Console.WriteLine("Customer Ip:" + requestData.CustomerIp);

            System.Console.WriteLine("<< RESPONSE >>");
            System.Console.WriteLine("MStatus:" + responseData.Mstatus);
            System.Console.WriteLine("Message:"+ responseData.MerrMsg);
            System.Console.WriteLine("Result Code:" + responseData.VResultCode);
            System.Console.WriteLine("Entry Form:" + responseData.EntryForm);
        }
    }
}
