﻿using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;
using System;

namespace ConsoleApplication.virtualacc
{
    /// <summary>
    /// 銀行振込決済 入金取消要求サンプル
    /// </summary>
    class CLI_VirtualaccDepositReverse
    {
        public virtual void Exec()
        {
            // 取引ID(入金請求時に利用したものを設定してください)
            String orderId = "";

            // 入金ID(入金請求時に受け取ったものを設定して下さい)
            String depositId = "";

            // サービスオプションタイプ
            // りそな : MdkServiceConstants.VACC_RESONA
            String serviceOptionType = MdkServiceConstants.VACC_RESONA;

            /**
             * 要求電文パラメータ値の指定
             */
            var requestData = new VirtualaccDepositReverseRequestDto();
            requestData.OrderId = orderId;
            requestData.DepositId = depositId;
            requestData.ServiceOptionType = serviceOptionType;

            /**
             * 実行と結果表示  
            */
            var tran = new Transaction();
            var responseData = (VirtualaccDepositReverseResponseDto)tran.Execute(requestData);

            System.Console.WriteLine("<< REQUEST >>");
            System.Console.WriteLine("Order ID:" + requestData.OrderId);
            System.Console.WriteLine("Deposit ID:" + requestData.DepositId);

            System.Console.WriteLine("<< RESPONSE >>");
            System.Console.WriteLine("OrderId:" + responseData.OrderId);
            System.Console.WriteLine("MStatus:" + responseData.Mstatus);
            System.Console.WriteLine("Message:" + responseData.MerrMsg);
            System.Console.WriteLine("Result Code:" + responseData.VResultCode);
            System.Console.WriteLine("Total Deposit Amount:" + responseData.TotalDepositAmount);
        }
    }
}
