﻿using System;
using System.Collections;

namespace MdkSampleDotNet
{

    /// <summary>
    /// サンプル購買情報クラス
    /// </summary>
    /// <remarks></remarks>
    public class Buyinfo
    {
        private ArrayList itemList = new ArrayList();

        public Buyinfo(bool createSampleItem)
        {
            BuyItem buyItem = new BuyItem("4G-S-0001","サンプル商品1","","1","10");
            itemList.Add(buyItem);

        }
        public String GetTotalAmount(){

            long total = 0;
            foreach (BuyItem buyItem in itemList)
            {
                total = total + buyItem.UnitCount * buyItem.UnitPrice;
            }
            return Convert.ToString(total);
        }
    }

    /// <summary>
    /// サンプル購買明細情報クラス
    /// </summary>
    /// <remarks></remarks>
    public class BuyItem
    {
        public BuyItem()
        {
        }
        /// <summary>
        /// コンストラクタ
        /// </summary>
        /// <param name="productNo">商品番号</param>
        /// <param name="productName">商品名</param>
        /// <param name="productImg">商品画像</param>
        /// <param name="unitCount">数量</param>
        /// <param name="unitPrice">単価</param>
        public BuyItem(
                String productNo,
                String productName,
                String productImg,
                String unitCount,
                String unitPrice
            )
        {
            ProductNo = productNo;
            ProductName = productName;
            ProductImg = productImg;
            UnitCount = Convert.ToInt32(unitCount);
            UnitPrice = Convert.ToInt32(unitPrice);
        }
        /// <summary>
        /// 商品番号
        /// </summary>
        private String productNo;
        public String ProductNo
        {
            get { return productNo; }
            set { productNo = value; }
        }
        /// <summary>
        /// 商品名
        /// </summary>
        private String productName;
        public String ProductName
        {
            get { return productName; }
            set { productName = value; }
        }
        /// <summary>
        /// 商品画像
        /// </summary>
        private String productImg;
        public String ProductImg
        {
            get { return productImg; }
            set { productImg = value; }
        }
        /// <summary>
        /// 数量
        /// </summary>
        private long unitCount;
        public long UnitCount
        {
            get { return unitCount; }
            set { unitCount = value; }
        }

        /// <summary>
        /// 単価
        /// </summary>
        private long unitPrice;
        public long UnitPrice
        {
            get { return unitPrice; }
            set { unitPrice = value; }
        }

    }
}
