﻿<%@ Page Language="C#" AutoEventWireup="True" CodeBehind="Authorize.aspx.cs" Inherits="MdkSampleDotNet.alipay.Authorize" %>

<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <meta http-equiv="Content-Language" content="ja" />
    <title>VeriTrans 4G - Alipay決済与信サンプル画面</title>
    <link href="../css/style.css" rel="stylesheet" type="text/css" />

    <script language="JavaScript" type="text/javascript">

        function changePayType() {
            var rdo = document.Form1.payType;
            if (rdo != null) {
                var obj = document.Form1.elements;
                for (i = 0; i < rdo.length; i++) {
                    if (rdo[i].checked) {
                        if (rdo[i].value == "1") {
                            obj.commodityDescription.value = "";
                            obj.commodityId.value = "";
                            obj.successUrl.value = "";
                            obj.errorUrl.value = "";
                        } else if (rdo[i].value == "2") {
                            obj.identityCode.value = "";
                            if (obj.commodityId.value == "") {
                                obj.commodityId.value = obj.hidCommodityId.value;
                            }
                            if (obj.commodityDescription.value == "") {
                                obj.commodityDescription.value = obj.hidCommodityDescription.value;
                            }
                            obj.successUrl.value = "";
                            obj.errorUrl.value = "";
                        } else {
                            obj.identityCode.value = "";
                            if (obj.commodityDescription.value == "") {
                                obj.commodityDescription.value = obj.hidCommodityDescription.value;
                            }
                            obj.commodityId.value = "";
                            if (obj.successUrl.value == "") {
                                obj.successUrl.value = obj.hidSuccessUrl.value;
                            }
                            if (obj.errorUrl.value == "") {
                                obj.errorUrl.value = obj.hidErrorUrl.value;
                            }
                        }
                    }
                }
            }
        }

        // onLoadイベント
        window.onload = function () {
            changePayType();
        }

    </script>

</head>
<body>
    <img alt='Paymentロゴ' src='../WEB-IMG/VeriTrans_Payment.png' /><hr />
    <div class="system-message">
        <font size="2">本画面はVeriTrans4G Alipay決済の取引サンプル画面です。<br />
            お客様ECサイトのショッピングカートとVeriTrans4Gとを連動させるための参考、例としてご利用ください。<br />
            また、本画面では基本的なパラメータのみを表示させていますので、開発ガイドも合わせてご参照してください。<br />
        </font>
    </div>
    <asp:Label ID="errorMessage" runat="server" />
    <table>
        <tr>
            <td>
                <div class="lhtitle">
                    Alipay決済：決済請求</div>
            </td>
            <td>
                <img alt="LOGO" src='../WEB-IMG/alipay.png' />
            </td>
            <td width="20">
                <br />
            </td>
        </tr>
    </table>
    <form id="Form1" name="FORM_ALIPAY" method="post" runat="server">
    <table border="0" cellpadding="0" cellspacing="0">
        <tr>
            <td class="ititletop">
                取引ID
            </td>
            <td class="ivaluetop">
                <asp:Label ID="orderId" runat="server" />&nbsp;&nbsp;
                <asp:Button ID="btnReplaceOrderId" runat="server" Text="取引ID更新" OnClick="btnReplaceOrderId_Click" />
            </td>
        </tr>
        <tr>
            <td class="ititle">
                金額
            </td>
            <td class="ivalue" style="width:640px;">
                <asp:TextBox ID="amount" runat="server" MaxLength="7" size="12" />
                <asp:RadioButtonList runat="server" ID="currency" RepeatDirection="Horizontal" RepeatLayout="Flow">
                    <asp:ListItem Enabled="true" Selected="True" Text="JPY" Value="JPY"></asp:ListItem>
                    <asp:ListItem Enabled="true" Text="CNY" Value="CNY"></asp:ListItem>
                </asp:RadioButtonList>
                <font size="2" color="red">※CNYの場合は、金額には100以上の値を指定する必要があります。</font>
            </td>
        </tr>
        <tr>
            <td class="ititle">
                決済種別
            </td>
            <td class="ivalue" style="width:640px;">
                <asp:RadioButtonList runat="server" ID="payType" RepeatDirection="Horizontal" RepeatLayout="Flow" OnClick="changePayType();">
                    <asp:ListItem Enabled="true" Selected="True" Text="オンライン決済" Value="0"></asp:ListItem>
                    <asp:ListItem Enabled="true" Text="バーコード決済(店舗スキャン型)" Value="1"></asp:ListItem>
                    <asp:ListItem Enabled="true" Text="バーコード決済(消費者スキャン型)" Value="2"></asp:ListItem>
                </asp:RadioButtonList>
            </td>
        </tr>
        <tr>
            <td class="ititle">
                ユーザ識別コード
            </td>
            <td class="ivalue">
                <asp:TextBox ID="identityCode" runat="server" MaxLength="32" size="35" />
            </td>
        </tr>
        <tr>
            <td class="ititle">
                商品名
            </td>
            <td class="ivalue">
                <asp:TextBox ID="commodityName" runat="server" MaxLength="100" size="35" />
            </td>
        </tr>
        <tr>
            <td class="ititle">
                商品詳細
            </td>
            <td class="ivalue">
                <asp:TextBox ID="commodityDescription" runat="server" Columns="75" Rows="6" TextMode="MultiLine"
                    MaxLength="200" />
            </td>
        </tr>
        <tr>
            <td class="ititle">
                商品ID
            </td>
            <td class="ivalue">
                <asp:TextBox ID="commodityId" runat="server" MaxLength="64" size="35" />
            </td>
        </tr>
        <tr>
            <td class="ititle">
                決済完了時URL
            </td>
            <td class="ivalue">
                <asp:TextBox ID="successUrl" runat="server" MaxLength="256" size="70" />
            </td>
        </tr>
        <tr>
            <td class="ititle">
                決済エラー時URL
            </td>
            <td class="ivalue">
                <asp:TextBox ID="errorUrl" runat="server" MaxLength="256" size="70" />
            </td>
        </tr>
        <tr>
            <td colspan="2">
                &nbsp;
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <asp:Button ID="btnSubmit" runat="server" Text="購入" OnClick="btnSubmit_Click" />&nbsp;&nbsp;<font
                    size="2" color="red">※２回以上クリックしないでください。</font>
            </td>
        </tr>
    </table>
    <asp:HiddenField ID="hidCommodityId" runat="server" />
    <asp:HiddenField ID="hidCommodityDescription" runat="server" />
    <asp:HiddenField ID="hidSuccessUrl" runat="server" />
    <asp:HiddenField ID="hidErrorUrl" runat="server" />
    </form>
    <a href="../PaymentMethodSelect.aspx">決済サンプルのトップメニューへ戻る</a>&nbsp;&nbsp;
    <hr />
    <img src='../WEB-IMG/VeriTransLogo_WH.png' alt='VeriTransロゴ'/>&nbsp; Copyright &copy; VeriTrans Inc.
    All rights reserved
</body>
</html>
