﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using jp.veritrans.tercerog.mdk.dto;
using jp.veritrans.tercerog.mdk;
using System.Reflection;
using jp.veritrans.tercerog.sample.util;
using System.Text;

namespace MdkSampleDotNet.carrier
{
    public partial class AuthorizeExec : System.Web.UI.Page
    {
        private Boolean displayContent = true;

        public Boolean DisplayContent
        {
            get { return this.displayContent; }
            set { this.displayContent = value; }
        }

        /// <summary>
        /// 初期表示イベント。
        /// パラメータを元に、GWと通信を行う。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            Response.Charset = "UTF-8";

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            String paramServiceOptionType = (String)Session["paramServiceOptionType"];
            String paramOrderId = (String)Session["paramOrderId"];
            String paramAmount = (String)Session["paramAmount"];
            String paramAccountingType = (String)Session["paramAccountingType"];
            String paramWithCapture = (String)Session["paramWithCapture"];
            String paramMpFirstDate = (String)Session["paramMpFirstDate"];
            String paramMpDay = (String)Session["paramMpDay"];
            String paramTerminalKind = (String)Session["paramTerminalKind"];
            String paramItemType = (String)Session["paramItemType"];
            String paramD3Flag = (String)Session["paramD3Flag"];
            String paramItemId = (String)Session["paramItemId"];
            String paramItemInfo = (String)Session["paramItemInfo"];
            String paramSuccessUrl = (String)Session["paramSuccessUrl"];
            String paramCancelUrl = (String)Session["paramCancelUrl"];
            String paramErrorUrl = (String)Session["paramErrorUrl"];
            String paramPushUrl = (String)Session["paramPushUrl"];
            String paramOpenId = (String)Session["paramOpenId"];
            String paramSbUid = (String)Session["paramSbUid"];
            String paramFletsArea = (String)Session["paramFletsArea"];
            String paramLoginAuId = (String)Session["paramLoginAuId"];

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 要求DTOを生成し、値を設定します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            CarrierAuthorizeRequestDto requestData = new CarrierAuthorizeRequestDto();
            requestData.ServiceOptionType = paramServiceOptionType;
            requestData.OrderId = paramOrderId;
            requestData.Amount = paramAmount;
            requestData.TerminalKind = paramTerminalKind;
            requestData.ItemType = paramItemType;
            requestData.AccountingType = paramAccountingType;
            if (MdkServiceConstants.CARRIER_MONTHLY.Equals(paramAccountingType))
            {
                requestData.MpFirstDate = paramMpFirstDate;
                requestData.MpDay = paramMpDay;
            }
            if (MdkServiceConstants.CARRIER_AUTH_WITH_CAPTURE.Equals(paramWithCapture))
            {
                requestData.WithCapture = "true";
            }
            if (MdkServiceConstants.CARRIER_SB_KTAI.Equals(paramServiceOptionType))
            {
                requestData.D3Flag = paramD3Flag;
            }
            requestData.ItemId = paramItemId;
            requestData.ItemInfo = paramItemInfo;
            requestData.SuccessUrl = paramSuccessUrl;
            requestData.CancelUrl = paramCancelUrl;
            requestData.ErrorUrl = paramErrorUrl;
            requestData.PushUrl = paramPushUrl;
            requestData.OpenId = paramOpenId;
            String dummyRequest = MerchantContext.Config.GetValue(MerchantConfig.DUMMY_REQUEST);
            if (MdkServiceConstants.CARRIER_S_BIKKURI.Equals(paramServiceOptionType))
            {
                if ("1".Equals(dummyRequest))
                {
                    requestData.SbUid = "Dummy12345678";
                }
                else
                {
                    requestData.SbUid = paramSbUid;
                }
            }
            requestData.FletsArea = paramFletsArea;
            requestData.LoginAuId = paramLoginAuId;
            try
            {
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // コマンドを実行し、応答DTOを取得します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                Transaction tran = new Transaction();
                CarrierAuthorizeResponseDto responseData = (CarrierAuthorizeResponseDto)tran.Execute(requestData);

                String responseContents = responseData.ResponseContents;
                String redirectUrl = responseData.RedirectUrl;
                if (!String.IsNullOrEmpty(responseContents))
                {
                    // レスポンスコンテンツがある場合はそのまま表示します。
                    // キャリアによって文字コードが異なるため、ここで文字コードを指定してください。
                    String charset = CarrierUtility.getEncoding(requestData.ServiceOptionType, requestData.TerminalKind);
                    Response.ContentType = "text/html; charset=" + charset;
                    Response.Charset = charset;
                    Response.ContentEncoding = Encoding.GetEncoding(charset);
                    Response.Write(responseContents);
                    displayContent = false;
                }
                else if (!String.IsNullOrEmpty(redirectUrl))
                {
                    Response.Redirect(redirectUrl);
                }
                else
                {
                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    // 結果画面に表示します。
                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    OrderId.Text = responseData.OrderId;
                    Mstatus.Text = responseData.Mstatus;
                    VResultCode.Text = responseData.VResultCode;
                    MerrMsg.Text = responseData.MerrMsg;
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Exception Occured !");
                Console.WriteLine("Exception Message: " + ex.Message);
                MerrMsg.Text = "Exception Occured : " + ex.Message;
            }
            Session.Clear();
        }
    }
}
