﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using jp.veritrans.tercerog.mdk.dto;
using jp.veritrans.tercerog.mdk;

namespace MdkSampleDotNet.carrier.mb
{
    public partial class Authorize : System.Web.UI.Page
    {
        /// <summary>
        /// 初期表示イベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Response.Charset = "Shift_JIS";
                orderId.Text = "dummy" + Utils.CurrentTimeMillis();
                amount.Text = Request.QueryString["price"];

                string successUrlStr = Request["successUrl"];
                if (successUrlStr == null)
                {
                    successUrlStr = MdkSampleDotNet.Utils.getXPath(MdkSampleDotNet.SampleConstants.CARRIER_SUCCESS_URL_MB);
                }
                string cancelUrlStr = Request["cancelUrl"];
                if (cancelUrlStr == null)
                {
                    cancelUrlStr = MdkSampleDotNet.Utils.getXPath(MdkSampleDotNet.SampleConstants.CARRIER_CANCEL_URL_MB);
                }
                string errorUrlStr = Request["errorUrl"];
                if (errorUrlStr == null)
                {
                    errorUrlStr = MdkSampleDotNet.Utils.getXPath(MdkSampleDotNet.SampleConstants.CARRIER_ERROR_URL_MB);
                }
                string pushUrlStr = Request["pushUrl"];
                if (pushUrlStr == null)
                {
                    pushUrlStr = MdkSampleDotNet.Utils.getXPath(MdkSampleDotNet.SampleConstants.CARRIER_PUSH_URL);
                }

                successUrl.Value = successUrlStr;
                cancelUrl.Value = cancelUrlStr;
                errorUrl.Value = errorUrlStr;
                String dummyRequest = MerchantContext.Config.GetValue(MerchantConfig.DUMMY_REQUEST);
                if ("1".Equals(dummyRequest))
                {
                    pushUrl.Value = pushUrlStr;
                }
                else
                {
                    pushUrl.Value = "";
                }

                serviceOptionType.Items.Add(new ListItem("ドコモ", MdkServiceConstants.CARRIER_DOCOMO));
                serviceOptionType.Items.Add(new ListItem("au", MdkServiceConstants.CARRIER_AU));
                serviceOptionType.Items.Add(new ListItem("S!まとめて支払い", MdkServiceConstants.CARRIER_S_BIKKURI));

                amount.Text = Request["amount"] + Request["price"];

                itemType.Items.Add(new ListItem("デジタルコンテンツ", MdkServiceConstants.CARRIER_ITEM_DIGITAL_CONTENTS));
                itemType.Items.Add(new ListItem("物販", MdkServiceConstants.CARRIER_ITEM_PRODUCT_SALES));
                itemType.Items.Add(new ListItem("役務", MdkServiceConstants.CARRIER_ITEM_SERVICES));

                accountingType.Items.Add(new ListItem("都度", MdkServiceConstants.CARRIER_ONETIME));
                accountingType.Items.Add(new ListItem("継続", MdkServiceConstants.CARRIER_ITEM_PRODUCT_SALES));

                withCapture.Items.Add(new ListItem("与信のみ(与信成功後に売上処理を行う必要があります)", MdkServiceConstants.CARRIER_AUTH_ONLY));
                withCapture.Items.Add(new ListItem("与信売上(与信と同時に売上処理も行います)", MdkServiceConstants.CARRIER_AUTH_WITH_CAPTURE));

                terminalKind.Value = MdkServiceConstants.CARRIER_TERMINAL_FP;

                mpFirstDate.Text = Request["mpFirstDate"];
                mpDay.Text = Request["mpDay"];
                itemId.Text = Request["itemId"];
                itemInfo.Value = Request["itemInfo"];
                openId.Text = Request["openId"];

                String sbUidStr = Request.Headers["x-jphone-uid"];
                sbUid.Value = sbUidStr;
            }
        }

        /// <summary>
        /// 取引ID更新ボタンイベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnReplaceOrderId_Click(object sender, EventArgs e)
        {
            orderId.Text = "dummy" + Utils.CurrentTimeMillis();
        }

        /// <summary>
        /// 購入ボタンイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            String paramServiceOptionType = serviceOptionType.SelectedValue;
            // 取引IDの取得
            String paramOrderId = orderId.Text;
            // 金額の取得
            String paramAmount = amount.Text;
            // 都度継続区分の取得
            String paramAccountingType = accountingType.SelectedValue;
            // 与信同時売上フラグの取得
            String paramWithCapture = withCapture.SelectedValue;
            // 初回課金年月日の取得
            String paramMpFirstDate = mpFirstDate.Text;
            // 継続課金日の取得
            String paramMpDay = mpDay.Text;

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 入力をチェックします。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            if (String.IsNullOrEmpty(paramOrderId))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramAmount))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font><br/><br/>";
                return;
            }
            if (!IsNumber(paramAmount))
            {
                errorMessage.Text = "<font color='#ff0000'><b>不正項目：金額は数値で入力しなければなりません</b></font><br/><br/>";
                return;
            }
            if (MdkServiceConstants.CARRIER_MONTHLY.Equals(paramAccountingType))
            {
                if (!paramServiceOptionType.Equals(MdkServiceConstants.CARRIER_SB_MATOMETE))
                {
                    if (String.IsNullOrEmpty(paramMpDay))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>必須項目：継続課金日が指定されていません</b></font><br/><br/>";
                        return;
                    }
                    else if (String.IsNullOrEmpty(paramMpFirstDate))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>必須項目：初回課金年月日が指定されていません</b></font><br/><br/>";
                        return;
                    }
                }
            }

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 画面入力値を実行クラスに渡すためにセッションに設定します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Session["paramServiceOptionType"] = paramServiceOptionType;
            Session["paramOrderId"] = paramOrderId;
            Session["paramAmount"] = paramAmount;
            Session["paramAccountingType"] = paramAccountingType;
            Session["paramWithCapture"] = paramWithCapture;
            Session["paramMpFirstDate"] = paramMpFirstDate;
            Session["paramMpDay"] = paramMpDay;
            Session["paramTerminalKind"] = terminalKind.Value;
            Session["paramItemType"] = itemType.SelectedValue;
            Session["paramItemId"] = itemId.Text;
            Session["paramItemInfo"] = itemInfo.Value;
            Session["paramSuccessUrl"] = successUrl.Value;
            Session["paramCancelUrl"] = cancelUrl.Value;
            Session["paramErrorUrl"] = errorUrl.Value;
            Session["paramPushUrl"] = pushUrl.Value;
            Session["paramOpenId"] = openId.Text;
            Session["paramSbUid"] = sbUid.Value;

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 実行＆結果画面を表示します
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Response.Redirect("./AuthorizeExec.aspx", true);
        }
        /// <summary>
        /// 引数が数値であるかを確認。
        /// </summary>
        /// <param name="strNum">確認する文字列</param>
        /// <returns>数値の場合はtrueを返す</returns>
        private bool IsNumber(string strNum)
        {
            double dNullable;

            return double.TryParse(
                strNum,
                System.Globalization.NumberStyles.Any,
                null,
                out dNullable
            );
        }
    }
}
