﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using jp.veritrans.tercerog.mdk.dto;
using jp.veritrans.tercerog.mdk;
using System.Reflection;
using jp.veritrans.tercerog.sample.util;
using System.Text;
using System.Security.Cryptography;

namespace MdkSampleDotNet.carrier.mb
{
    public partial class Result : System.Web.UI.Page
    {
        private string warning;

        public String Warning
        {
            get { return warning; }
            set { warning = value; }
        }
        /// <summary>
        /// 初期表示イベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            Response.Charset = "Shift_JIS";
            if (!IsPostBack)
            {
                String command = Request["command"];
                String strCommand = "";
                if ("Authorize".Equals(command))
                {
                    strCommand = "決済";
                }
                else if ("Terminate".Equals("Terminate"))
                {
                    strCommand = "継続課金終了";
                }

                String result = Request["result"];
                String strResult = "";
                if ("SUCCESS".Equals(result))
                {
                    strResult = "完了";
                }
                else if ("CANCEL".Equals(result))
                {
                    strResult = "キャンセル";
                }
                else if ("ERROR".Equals(result))
                {
                    strResult = "エラー";
                }

                lblResult.Text = strResult;
                lblCommandResult.Text = strCommand + strResult;

                warning = null;

                String merchantId = MerchantContext.Config.GetValue(MerchantConfig.MERCHANT_CC_ID);
                String merchantPw = MerchantContext.Config.GetValue(MerchantConfig.MERCHANT_SECRET_KEY);
                if (String.IsNullOrEmpty(merchantId) || String.IsNullOrEmpty(merchantPw))
                {
                    warning = "<font color='#ff0000'><b>マーチャントCCIDまたはマーチャントパスワードが設定されていません。</b></font>";
                }
                else
                {
                    // ハッシュ値算出
                    // 連結したパラメータ（リクエスト、パラメータ順序、マーチャントCCID、マーチャントパスワード）、アルゴリズム、文字コードでハッシュ値を算出する。
                    String hash = createAuthHashInfo(merchantId, merchantPw);
                    // 改ざんチェック用ハッシュ値の取得
                    String vAuthInfo = Request["vAuthInfo"];
                    // 算出したハッシュ値とパラメータ取得したハッシュ値を比較し、異なる場合は改竄とみなす。
                    if (!hash.Equals(vAuthInfo))
                    {
                        warning = "<font color='#ff0000'><b>【パラメータ改竄】パラメータ情報が改竄されています。</b></font>";
                    }
                    else
                    {
                        OrderId.Text = Request["orderId"];
                        Mstatus.Text = Request["mstatus"];
                        VResultCode.Text = Request["vResultCode"];
                    }
                }
            }
        }

        /// <summary>
        /// ハッシュ値算出
        /// </summary>
        /// <param name="merchantId"></param>
        /// <param name="merchantPw"></param>
        private String createAuthHashInfo(String merchantId, String merchantPw)
        {
            // ハッシュ値算出パラメータ順序の取得
            String authParams = Request["authParams"];

            // ハッシュ値算出パラメータ順序のデコード
            byte[] bytesBase64 = Util.FromBase64(authParams);
            String[] paramOrder = Encoding.Default.GetString(bytesBase64).Split(',');

            // パラメータ順序順にパラメータを取得し、連結させる。
            StringBuilder paramSb = new StringBuilder();
            paramSb.Append(merchantId);
            for (int i = 0; i < paramOrder.Length; i++)
            {
                paramSb.Append(Request[paramOrder[i]]);
            }
            paramSb.Append(merchantPw);

            // 連結したパラメータ値から指定されたアルゴリズムのダイジェストを生成
            SHA256 shaM = new SHA256Managed();
            // ダイジェスト値をバイト型で取得
            byte[] hashBytes = shaM.ComputeHash(Encoding.UTF8.GetBytes(paramSb.ToString()));

            // ハッシュ値用ビルダ
            StringBuilder sbHash = new StringBuilder();
            String hex = "";
            // バイト単位に2桁の16進数表現に変換
            foreach (byte b in hashBytes)
            {
                hex = String.Format("{0:x2}", b);
                sbHash.Append(hex);
            }

            return sbHash.ToString();
        }
    }
}
