﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;

namespace MdkSampleDotNet.cvs
{
    public partial class Authorize : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                orderId.Text = "dummy" + Utils.CurrentTimeMillis();
                amount.Text = Request.QueryString["price"];
            }
        }

        /// <summary>
        /// 取引ID更新ボタンイベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnReplaceOrderId_Click(object sender, EventArgs e)
        {
            orderId.Text = "dummy" + Utils.CurrentTimeMillis();
        }

        /// <summary>
        /// 購入ボタンイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 決済方式
            String paramServiceOptionType = serviceOptionType.SelectedValue;
            // 取引ID
            String paramOrderId = orderId.Text;
            // 決済金額
            String paramAmount = amount.Text;
            // 氏名1（姓）
            String paramName1 = name1.Text;
            // 氏名2(名)
            String paramName2 = name2.Text;
            // 電話番号
            String paramTelephoneNumber = telNo.Text;
            // 支払期限
            String paramPaymentLimit = payLimit.Text;


            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 入力をチェックします。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            if (String.IsNullOrEmpty(paramOrderId))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramAmount))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：決済金額が指定されていません</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramName1))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：姓が指定されていません</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramName2))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：名が指定されていません</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramTelephoneNumber))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：電話番号が指定されていません</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramPaymentLimit))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：支払期限が指定されていません</b></font><br/><br/>";
                return;
            }


            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 画面入力値を実行クラスに渡すためにセッションに設定します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Session["paramServiceOptionType"] = paramServiceOptionType;
            Session["paramOrderId"] = paramOrderId;
            Session["paramAmount"] = paramAmount;
            Session["paramName1"] = paramName1;
            Session["paramName2"] = paramName2;
            Session["paramTelephoneNumber"] = paramTelephoneNumber;
            Session["paramPaymentLimit"] = paramPaymentLimit;


            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 実行＆結果画面を表示します
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Response.Redirect("./AuthorizeExec.aspx", true);

            return;
        }
    }
}
