﻿using System;

namespace MdkSampleDotNet.em
{
    public partial class Authorize : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                orderId.Text = "dummy" + Utils.CurrentTimeMillis();
                amount.Text = Request.QueryString["price"];
            }
        }

        protected void btnReplaceOrderId_Click(object sender, EventArgs e)
        {
            orderId.Text = "dummy" + Utils.CurrentTimeMillis();
        }

        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 決済方式
            String paramServiceOptionType = serviceOptionType.SelectedValue;
            // 取引ID
            String paramOrderId = orderId.Text;
            // 決済金額
            String paramAmount = amount.Text;
            // メールアドレス
            String paramMailAddress = mailAddress.Text;
            // 決済期限(パソリ未使用)
            String paramSettlementLimit = settlementLimit.Text;
            // User Id
            String paramUserId = userId.Text;


            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 入力をチェックします。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            if (String.IsNullOrEmpty(paramOrderId))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramAmount))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：決済金額が指定されていません</b></font><br/><br/>";
                return;
            }
            if (!"edy-pc".Equals(paramServiceOptionType) && 
                !"edy-direct".Equals(paramServiceOptionType) && 
                !"tcc-redirect".Equals(paramServiceOptionType) 
                && String.IsNullOrEmpty(paramSettlementLimit))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：決済期限が指定されていません</b></font><br/><br/>";
                return;
            }

            if (!"edy-pc".Equals(paramServiceOptionType) &&
                !"edy-direct".Equals(paramServiceOptionType) &&
                !"suica-mobile-app".Equals(paramServiceOptionType) &&
                !"suica-pc-app".Equals(paramServiceOptionType) &&
                !"tcc-redirect".Equals(paramServiceOptionType) &&
                String.IsNullOrEmpty(paramMailAddress))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：メールアドレスが指定されていません</b></font><br/><br/>";
                return;
            }
            if ("tcc-redirect".Equals(paramServiceOptionType) &&
                String.IsNullOrEmpty(paramUserId)
                )
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：ユーザIDが指定されていません</b></font><br/><br/>";
                return;
            }




            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 画面入力値を実行クラスに渡すためにセッションに設定します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Session["paramServiceOptionType"] = paramServiceOptionType;
            Session["paramOrderId"] = paramOrderId;
            Session["paramAmount"] = paramAmount;
            Session["paramMailAddress"] = paramMailAddress;
            Session["paramSettlementLimit"] = paramSettlementLimit;
            Session["userId"] = paramUserId;


            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 実行＆結果画面を表示します
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Response.Redirect("./AuthorizeExec.aspx", true);

            return;
        }
    }
}
