﻿using System;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace MdkSampleDotNet.em
{
    public partial class AuthorizeExec : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            String paramServiceOptionType = (String)Session["paramServiceOptionType"];
            String paramOrderId = (String)Session["paramOrderId"];
            String paramAmount = (String)Session["paramAmount"];
            String paramMailAddress = (String)Session["paramMailAddress"];
            String paramSettlementLimit = (String)Session["paramSettlementLimit"];
            String paramUserId = (String)Session["userId"];


            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 要求DTOを生成し、値を設定します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            EmAuthorizeRequestDto requestData = new EmAuthorizeRequestDto();
            requestData.ServiceOptionType = paramServiceOptionType;
            requestData.OrderId = paramOrderId;
            requestData.Amount = paramAmount;
            if (!"edy-pc".Equals(paramServiceOptionType) && !"edy-direct".Equals(paramServiceOptionType))
            {
                requestData.SettlementLimit = paramSettlementLimit;
            }
            if (!"edy-pc".Equals(paramServiceOptionType) &&
                !"edy-direct".Equals(paramServiceOptionType) &&
                !"suica-mobile-app".Equals(paramServiceOptionType) &&
                !"suica-pc-app".Equals(paramServiceOptionType) &&
                !"tcc-redirect".Equals(paramServiceOptionType))
            {
                requestData.MailAddr = paramMailAddress;
            }
            if (!"edy-pc".Equals(paramServiceOptionType) &&
                !"edy-mobile".Equals(paramServiceOptionType) &&
                !"edy-direct".Equals(paramServiceOptionType) &&
                !"waon-pc".Equals(paramServiceOptionType) &&
                !"waon-mobile".Equals(paramServiceOptionType) && 
                !"tcc-redirect".Equals(paramServiceOptionType))
            {
                requestData.ScreenTitle = "画面タイトルサンプル";
            }
            if ("waon-pc".Equals(paramServiceOptionType))
            {
                requestData.SuccessUrl = "http://127.0.0.1/web/PaymentMethodSelect.aspx?status=success";
                requestData.FailureUrl = "http://127.0.0.1/web/PaymentMethodSelect.aspx?status=failure";
                requestData.CancelUrl = "http://127.0.0.1/web/PaymentMethodSelect.aspx?status=cancel";

                requestData.CancelLimit = paramSettlementLimit;
            }
            if ("waon-mobile".Equals(paramServiceOptionType))
            {
                requestData.CancelLimit = paramSettlementLimit;
            }
            if ("tcc-redirect".Equals(paramServiceOptionType))
            {
                requestData.UserId = paramUserId;
                requestData.TransactionKind = "02";
                requestData.CompleteNoticeUrl = Utils.getXPath(SampleConstants.EM_COMPLETE_NOTICE_URL);
            }

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // コマンドを実行し、応答DTOを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            Transaction tran = new Transaction();
            EmAuthorizeResponseDto responseData = (EmAuthorizeResponseDto)tran.Execute(requestData);


            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 結果画面に表示します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            OrderId.Text = responseData.OrderId;
            Mstatus.Text = responseData.Mstatus;
            VResultCode.Text = responseData.VResultCode;
            MerrMsg.Text = responseData.MerrMsg;

            ReceiptNo.Text = responseData.ReceiptNo;
            if (string.IsNullOrEmpty(responseData.AppUrl))
            {
                AppUrl.Visible = false;
            }
            else
            {
                AppUrl.Visible = true;
                AppUrl.NavigateUrl = responseData.AppUrl;

                if ("tcc-redirect".Equals(paramServiceOptionType))
                {
                    Response.Redirect(responseData.AppUrl,true);
                }

            }
        }
    }
}
