﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace MdkSampleDotNet.em
{
    public partial class RefundExec : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            String paramServiceOptionType = (String)Session["paramServiceOptionType"];
            String paramOrderKind = (String)Session["paramOrderKind"];
            String paramAmount = (String)Session["paramAmount"];
            String paramOrderId = (String)Session["paramOrderId"];
            String paramRefundOrderId = (String)Session["paramRefundOrderId"];
            String paramSettlementLimit = (String)Session["paramSettlementLimit"];
            String paramScreenTitle = (String)Session["paramScreenTitle"];


            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 要求DTOを生成し、値を設定します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            EmRefundRequestDto requestData = new EmRefundRequestDto();
            requestData.ServiceOptionType = paramServiceOptionType;
            requestData.OrderId = paramOrderId;
            requestData.RefundOrderId = paramRefundOrderId;
            requestData.OrderKind = paramOrderKind;
            requestData.Amount = paramAmount;
            if ("edy-mobile".Equals(paramServiceOptionType) == false &&
                "edy-direct".Equals(paramServiceOptionType) == false &&
                "edy-pc".Equals(paramServiceOptionType) == false)
            {
                requestData.SettlementLimit = paramSettlementLimit;
            }
            if ("waon-pc".Equals(paramServiceOptionType)) {
                requestData.SuccessUrl = "http://127.0.0.1/web/PaymentMethodSelect.aspx?status=success";
                requestData.FailureUrl = "http://127.0.0.1/web/PaymentMethodSelect.aspx?status=failure";
                requestData.CancelUrl = "http://127.0.0.1/web/PaymentMethodSelect.aspx?status=cancel";
            }
            if ("waon-pc".Equals(paramServiceOptionType) == false &&
                "waon-mobile".Equals(paramServiceOptionType) == false)
            {
                requestData.ScreenTitle = paramScreenTitle;
            }


            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // コマンドを実行し、応答DTOを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            Transaction tran = new Transaction();
            EmRefundResponseDto responseData = (EmRefundResponseDto)tran.Execute(requestData);


            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 結果画面に表示します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            OrderId.Text = responseData.OrderId;
            Mstatus.Text = responseData.Mstatus;
            VResultCode.Text = responseData.VResultCode;
            MerrMsg.Text = responseData.MerrMsg;

            ReceiptNo.Text = responseData.ReceiptNo;
            if (responseData.AppUrl == null || responseData.AppUrl.Length == 0)
            {
                AppUrl.Visible = false;
            }
            else
            {
                AppUrl.Visible = true;
                AppUrl.NavigateUrl = responseData.AppUrl;
            }
        }
    }
}
