﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using MdkSampleDotNet;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace web.masterpass
{
    public partial class Login : System.Web.UI.Page
    {
        /// <summary>
        /// 初期表示イベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                orderId.Text = "dummy" + Utils.CurrentTimeMillis();
                itemAmount.Text = Request.QueryString["value1"];
                itemAmount.Text = Request["value1"];
                dummyRequest.Value = MerchantContext.Config.GetValue(MerchantConfig.DUMMY_REQUEST);

                suppressShippingAddress.Items.Add(new ListItem("false", MdkServiceConstants.MASTERPASS_SUPPRESS_SHIPPING_ADDRESS_0));
                suppressShippingAddress.Items.Add(new ListItem("true（Supress-抑止する）", MdkServiceConstants.MASTERPASS_SUPPRESS_SHIPPING_ADDRESS_1));

                string successUrlStr = Request["successUrl"];
                if (successUrlStr == null)
                {
                    successUrlStr = MdkSampleDotNet.Utils.getXPath(MdkSampleDotNet.SampleConstants.MASTERPASS_SUCCESS_URL);
                }
                string cancelUrlStr = Request["cancelUrl"];
                if (cancelUrlStr == null)
                {
                    cancelUrlStr = MdkSampleDotNet.Utils.getXPath(MdkSampleDotNet.SampleConstants.MASTERPASS_CANCEL_URL);
                }
                string errorUrlStr = Request["errorUrl"];
                if (errorUrlStr == null)
                {
                    errorUrlStr = MdkSampleDotNet.Utils.getXPath(MdkSampleDotNet.SampleConstants.MASTERPASS_ERROR_URL);
                }

                successUrl.Text = successUrlStr;
                cancelUrl.Text = cancelUrlStr;
                errorUrl.Text = errorUrlStr;

                description1.Text = Request["description1"];
                quantity1.Text = Request["quantity1"];
                value1.Text = Request["value1"];
            }
        }

        /// <summary>
        /// 取引ID更新ボタンイベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnReplaceOrderId_Click(object sender, EventArgs e)
        {
            orderId.Text = "dummy" + Utils.CurrentTimeMillis();
        }

        /// <summary>
        /// 購入ボタンイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 取引IDの取得
            String paramOrderId = orderId.Text;
            // 合計金額の取得
            String paramItemAmount = inputItemAmount.Value;

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 入力をチェックします。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            if (String.IsNullOrEmpty(paramOrderId))
            {
                errorMessage.Text = "<font color='#ff0000'><b>Unset Order Id<br>(必須項目：取引IDが指定されていません)</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramItemAmount))
            {
                errorMessage.Text = "<font color='#ff0000'><b>Unset Total Amount<br>(必須項目：合計金額が指定されていません)</b></font><br/><br/>";
                return;
            }

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 画面入力値を実行クラスに渡すためにセッションに設定します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Session["paramOrderId"] = paramOrderId;
            Session["paramItemId"] = itemId.Text;
            Session["paramItemAmount"] = paramItemAmount;
            Session["paramDescription1"] = description1.Text;
            Session["paramQuantity1"] = quantity1.Text;
            Session["paramValue1"] = value1.Text;
            Session["paramImageUrl1"] = imageUrl1.Text;
            Session["paramDescription2"] = description2.Text;
            Session["paramQuantity2"] = quantity2.Text;
            Session["paramValue2"] = value2.Text;
            Session["paramImageUrl2"] = imageUrl2.Text;
            Session["paramDescription3"] = description3.Text;
            Session["paramQuantity3"] = quantity3.Text;
            Session["paramValue3"] = value3.Text;
            Session["paramImageUrl3"] = imageUrl3.Text;
            Session["paramDescription4"] = description4.Text;
            Session["paramQuantity4"] = quantity4.Text;
            Session["paramValue4"] = value4.Text;
            Session["paramImageUrl4"] = imageUrl4.Text;
            Session["paramDescription5"] = description5.Text;
            Session["paramQuantity5"] = quantity5.Text;
            Session["paramValue5"] = value5.Text;
            Session["paramImageUrl5"] = imageUrl5.Text;
            Session["paramDescription6"] = description6.Text;
            Session["paramQuantity6"] = quantity6.Text;
            Session["paramValue6"] = value6.Text;
            Session["paramImageUrl6"] = imageUrl6.Text;
            Session["paramDescription7"] = description7.Text;
            Session["paramQuantity7"] = quantity7.Text;
            Session["paramValue7"] = value7.Text;
            Session["paramImageUrl7"] = imageUrl7.Text;
            Session["paramDescription8"] = description8.Text;
            Session["paramQuantity8"] = quantity8.Text;
            Session["paramValue8"] = value8.Text;
            Session["paramImageUrl8"] = imageUrl8.Text;
            Session["paramDescription9"] = description9.Text;
            Session["paramQuantity9"] = quantity9.Text;
            Session["paramValue9"] = value9.Text;
            Session["paramImageUrl9"] = imageUrl9.Text;
            Session["paramDescription10"] = description10.Text;
            Session["paramQuantity10"] = quantity10.Text;
            Session["paramValue10"] = value10.Text;
            Session["paramImageUrl10"] = imageUrl10.Text;
            Session["paramSuppressShippingAddress"] = suppressShippingAddress.SelectedValue;
            Session["paramShippingLocationProfile"] = shippingLocationProfile.Text;
            Session["paramSuccessUrl"] = successUrl.Text;
            Session["paramCancelUrl"] = cancelUrl.Text;
            Session["paramErrorUrl"] = errorUrl.Text;

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 実行＆結果画面を表示します
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Response.Redirect("./LoginExec.aspx", true);
        }

    }
}
