﻿using System;
using jp.veritrans.tercerog.mdk.dto;
using jp.veritrans.tercerog.mdk;

namespace MdkSampleDotNet.mpi
{
    public partial class AuthorizeExec : System.Web.UI.Page
    {
        /// <summary>
        /// 初期表示イベント。
        /// パラメータを元に、GWと通信を行う。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            String paramOrderId = (String)Session["paramOrderId"];
            String paramAmount = (String)Session["paramAmount"];
            String paramPaymentMode = (String)Session["paramPaymentMode"];
            String paramWithCapture = (String)Session["paramWithCapture"];
            String paramJpo = (String)Session["paramJpo"];
            String paramToken = (String) Session["paramToken"];
            String paramPushUrl = (String)Session["paramPushUrl"];
            // リダイレクトされるURL
            String paramRedirectionUri = Utils.getXPath(SampleConstants.MPI_REDIRECT_URL);

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 要求DTOを生成し、値を設定します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            MpiAuthorizeRequestDto requestData = new MpiAuthorizeRequestDto();
            String paramServiceOptionType = "";
            if ("1".Equals(paramPaymentMode))
            {
                paramServiceOptionType = "mpi-none";
            }
            else if ("2".Equals(paramPaymentMode))
            {
                paramServiceOptionType = "mpi-complete";
            }
            else if ("3".Equals(paramPaymentMode))
            {
                paramServiceOptionType = "mpi-company";
            }
            else if ("4".Equals(paramPaymentMode))
            {
                paramServiceOptionType = "mpi-merchant";
            }
            requestData.ServiceOptionType = paramServiceOptionType;
            requestData.OrderId = paramOrderId;
            requestData.Amount = paramAmount;
            requestData.WithCapture = paramWithCapture;
            if (!String.IsNullOrEmpty(paramJpo))
            {
                requestData.Jpo = paramJpo;
            }
            requestData.Token = paramToken;
            if (!String.IsNullOrEmpty(paramRedirectionUri))
            {
                requestData.RedirectionUri = paramRedirectionUri;
            }
            if (!String.IsNullOrEmpty(paramPushUrl))
            {
                requestData.PushUrl = paramPushUrl;
            }

            requestData.HttpUserAgent = Request.UserAgent;
            var strings = Request.ServerVariables.GetValues("HTTP_ACCEPT");
            if (strings != null)
                requestData.HttpAccept = strings.ToString();

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // コマンドを実行し、応答DTOを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            var tran = new Transaction();
            var responseData = (MpiAuthorizeResponseDto)tran.Execute(requestData);

            OrderId.Text = responseData.OrderId;
            Mstatus.Text = responseData.Mstatus;
            VResultCode.Text = responseData.VResultCode;
            MerrMsg.Text = responseData.MerrMsg;
            // 判定
            if (SampleConstants.TXN_FAILURE_CODE.Equals(responseData.Mstatus))
            {
            }
            else
            {
                // 成功
                Response.Write(responseData.ResResponseContents);
            }

        }
    }
}
