﻿using System;

namespace MdkSampleDotNet.mpi
{
    public partial class ReAuthorize : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                orderId.Text = "dummy" + DateTime.Now.ToString("HHmmssfff");
                amount.Text = Request.QueryString["price"];
            }
        }

        protected void btnReplaceOrderId_Click(object sender, EventArgs e)
        {
            orderId.Text = "dummy" + DateTime.Now.ToString("HHmmssfff");
        }

        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 取引ID
            String paramOrderId = orderId.Text;
            // 元取引ID
            String paramOriginalOrderId = originalOrderId.Text;
            // 支払金額
            String paramAmount = amount.Text;
            // 決済種別
            String paramPaymentMode = paymentMode.SelectedValue;
            // 与信方法
            // false： 与信のみ
            // true: 同時売上
            string paramWithCapture = withCapture.SelectedValue.Equals("1") ?
                SampleConstants.MDK_PARAM_TRUE : SampleConstants.MDK_PARAM_FALSE;

            // 支払オプション
            String paramJpo1 = jpo1.SelectedValue;
            String paramJpo2 = jpo2.Text;
            String paramJpo = "";
            if (!String.IsNullOrEmpty(paramJpo1))
            {
                if ("10".Equals(paramJpo1) || "80".Equals(paramJpo1))
                {
                    paramJpo = paramJpo1;
                }
                else if ("61".Equals(paramJpo1) || paramJpo2 != null)
                {
                    paramJpo = paramJpo1 + "C" + paramJpo2;
                }
            }
            // セキュリティコード
            String paramSecurityCode = securityCode.Text;
            String paramPushUrl = pushUrl.Text;

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 入力をチェックします。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            if (String.IsNullOrEmpty(paramOrderId))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramOriginalOrderId))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：元取引IDが指定されていません</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramAmount))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font><br/><br/>";
                return;
            }


            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 画面入力値を実行クラスに渡すためにセッションに設定します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Session["paramOrderId"] = paramOrderId;
            Session["paramOriginalOrderId"] = paramOriginalOrderId;
            Session["paramAmount"] = paramAmount;
            Session["paramPaymentMode"] = paramPaymentMode;
            Session["paramWithCapture"] = paramWithCapture;
            Session["paramJpo"] = paramJpo;
            Session["paramSecurityCode"] = paramSecurityCode;
            Session["paramPushUrl"] = paramPushUrl;

            Session["reAuthorizeFlg"] = "1";


            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 実行＆結果画面を表示します
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Response.Redirect("./ReAuthorizeExec.aspx", true);
            
            return;
        }
    }
}
