﻿using System;
using System.Web;
using System.Web.UI;
using jp.veritrans.tercerog.mdk;

namespace web.mpi
{
    public partial class Result : Page
    {
        public String Warning { get; set; }

        protected void Page_Load(object sender, EventArgs e)
        {
            Response.Charset = "UTF-8";
            if (!IsPostBack)
            {
                OrderId.Text = HttpUtility.HtmlEncode(Request["OrderId"]);
                RequestId.Text = HttpUtility.HtmlEncode(Request["RequestId"]);
                mpiMstatus.Text = HttpUtility.HtmlEncode(Request["mpiMstatus"]);
                cardMstatus.Text = HttpUtility.HtmlEncode(Request["cardMstatus"]);
                vResultCode.Text = HttpUtility.HtmlEncode(Request["vResultCode"]);
                reqCurrencyUnit.Text = HttpUtility.HtmlEncode(Request["reqCurrencyUnit"]);
                cardTransactionType.Text = HttpUtility.HtmlEncode(Request["cardTransactionType"]);
                centerRequestDate.Text = HttpUtility.HtmlEncode(Request["centerRequestDate"]);
                centerResponseDate.Text = HttpUtility.HtmlEncode(Request["centerResponseDate"]);
                connectedCenterId.Text = HttpUtility.HtmlEncode(Request["connectedCenterId"]);
                reqCardNumber.Text = HttpUtility.HtmlEncode(Request["reqCardNumber"]);
                reqAmount.Text = HttpUtility.HtmlEncode(Request["reqAmount"]);
                acquirerCode.Text = HttpUtility.HtmlEncode(Request["acquirerCode"]);
                authCode.Text = HttpUtility.HtmlEncode(Request["authCode"]);
                dddMessageVersion.Text = HttpUtility.HtmlEncode(Request["dddMessageVersion"]);
                dddTransactionId.Text = HttpUtility.HtmlEncode(Request["dddTransactionId"]);
                dddTransactionStatus.Text = HttpUtility.HtmlEncode(Request["dddTransactionStatus"]);
                dddCavvAlgorithm.Text = HttpUtility.HtmlEncode(Request["dddCavvAlgorithm"]);
                dddCavv.Text = HttpUtility.HtmlEncode(Request["dddCavv"]);
                dddEci.Text = HttpUtility.HtmlEncode(Request["dddEci"]);

                Warning = null;

                String merchantId = MerchantContext.Config.GetValue(MerchantConfig.MERCHANT_CC_ID);
                String merchantPw = MerchantContext.Config.GetValue(MerchantConfig.MERCHANT_SECRET_KEY);
                if (String.IsNullOrEmpty(merchantId) || String.IsNullOrEmpty(merchantPw))
                {
                    Warning = "<font color='#ff0000'><b>マーチャントCCIDまたはマーチャントパスワードが設定されていません。</b></font>";
                }
                else
                {
                    // パラメータ改ざんチェック
                    if (!AuthHashUtil.CheckAuthHash(Request.Params, merchantId, merchantPw))
                    {
                        Warning = "<font color='#ff0000'><b>【パラメータ改竄】パラメータ情報が改竄されています。</b></font>";
                    }
                }
            }
        }



    }
}
