﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using jp.veritrans.tercerog.mdk.dto;
using jp.veritrans.tercerog.mdk;

namespace MdkSampleDotNet.oricosc.mb
{
    public partial class Authorize : System.Web.UI.Page
    {
        /// <summary>
        /// 初期表示イベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            Response.Charset = "Shift_JIS";
            if (!Page.IsPostBack)
            {
                String dummyOrderId = "dummy" + Utils.CurrentTimeMillis();
                orderId.Text = dummyOrderId;
                oricoOrderNo.Text = dummyOrderId;

                if (null == Request["itemName1"])
                {
                    itemName1.Text = Utils.GetRequestParameter(Request, "item1_name");
                }
                else
                {
                    itemName1.Text = Utils.GetRequestParameter(Request, "itemName1");
                }

                if (null == Request["itemCount1"])
                {
                    itemCount1.Text = Request["item1_quantity"];
                }
                else
                {
                    itemCount1.Text = Request["itemCount1"];
                }

                if (null == Request["itemAmount1"])
                {
                    itemAmount1.Text = Request["item1_price"];
                }
                else
                {
                    itemAmount1.Text = Request["itemAmount1"];
                }
            }
        }

        /// <summary>
        /// 購入ボタンイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 取引ID
            String paramOrderId = orderId.Text;
            // 注文番号
            String paramOricoOrderNo = oricoOrderNo.Text;
            // 会員番号(加盟店)
            String paramUserNo = userNo.Text;
            // 商品名１
            String paramItemName1 = itemName1.Text;
            // 数量１
            String paramItemCount1 = itemCount1.Text;
            // 商品価格１(税込)
            String paramItemAmount1 = itemAmount1.Text;
            // 商品名２
            String paramItemName2 = itemName2.Text;
            // 数量２
            String paramItemCount2 = itemCount2.Text;
            // 商品価格２(税込)
            String paramItemAmount2 = itemAmount2.Text;
            // 商品名３
            String paramItemName3 = itemName3.Text;
            // 数量３
            String paramItemCount3 = itemCount3.Text;
            // 商品価格３(税込)
            String paramItemAmount3 = itemAmount3.Text;
            // 商品名４
            String paramItemName4 = itemName4.Text;
            // 数量４
            String paramItemCount4 = itemCount4.Text;
            // 商品価格４(税込)
            String paramItemAmount4 = itemAmount4.Text;
            // 商品名５
            String paramItemName5 = itemName5.Text;
            // 数量５
            String paramItemCount5 = itemCount5.Text;
            // 商品価格５(税込)
            String paramItemAmount5 = itemAmount5.Text;
            // 商品価格合計(税込)
            String paramTotalItemAmount = totalItemAmount.Text;
            // 送料合計(税込)
            String paramTotalCarriage = totalCarriage.Text;
            // 支払金額合計
            String paramAmount = amount.Text;
            // 頭金
            String paramDeposit = deposit.Text;
            // 配送先郵便番号
            String paramShippingZipCode = shippingZipCode.Text;
            // 取扱契約番号
            String paramHandlingContractNo = handlingContractNo.Text;
            // 契約書有無区分
            String paramContractDocumentKbn = contractDocumentKbn.Text;
            // WEB申込商品ID
            String paramWebDescriptionId = webDescriptionId.Text;

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 入力をチェックします。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            int dummyValue;
            errorMessage.Text = "";
            if (String.IsNullOrEmpty(paramOrderId))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font>";
            }
            else if (String.IsNullOrEmpty(paramOricoOrderNo))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：注文番号が指定されていません</b></font>";
            }
            else if (String.IsNullOrEmpty(paramShippingZipCode))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：配送先郵便番号が指定されていません</b></font>";
            }
            else if (String.IsNullOrEmpty(paramItemName1))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：商品名１が指定されていません</b></font>";
            }
            else if (String.IsNullOrEmpty(paramItemCount1))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：数量１が指定されていません</b></font>";
            }
            else if (String.IsNullOrEmpty(paramItemAmount1))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：商品価格１(税込)が指定されていません</b></font>";
            }
            else if (!int.TryParse(paramItemCount1, out dummyValue))
            {
                errorMessage.Text = "<font color='#ff0000'><b>数量１は数値で入力しなければなりません</b></font>";
            }
            else if (!int.TryParse(paramItemAmount1, out dummyValue))
            {
                errorMessage.Text = "<font color='#ff0000'><b>商品価格１(税込)は数値で入力しなければなりません</b></font>";
            }
            else if (String.IsNullOrEmpty(paramTotalItemAmount))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：商品価格合計(税込)が指定されていません</b></font>";
            }
            else if (!int.TryParse(paramTotalItemAmount, out dummyValue))
            {
                errorMessage.Text = "<font color='#ff0000'><b>商品価格合計(税込)は数値で入力しなければなりません</b></font>";
            }
            else if (String.IsNullOrEmpty(paramAmount))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：支払金額合計が指定されていません</b></font>";
            }
            else if (!int.TryParse(paramAmount, out dummyValue))
            {
                errorMessage.Text = "<font color='#ff0000'><b>支払金額合計は数値で入力しなければなりません</b></font>";
            }


            // 商品２の整合性チェック
            if (String.IsNullOrEmpty(errorMessage.Text))
            {
                if (!String.IsNullOrEmpty(paramItemName2))
                {
                    if (String.IsNullOrEmpty(paramItemCount2))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>数量２が指定されていません</b></font>";
                    }
                    else if (String.IsNullOrEmpty(paramItemAmount2))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品価格２(税込)が指定されていません</b></font>";
                    }
                }
                else if (!String.IsNullOrEmpty(paramItemCount2))
                {
                    if (String.IsNullOrEmpty(paramItemName2))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品名２が指定されていません</b></font>";
                    }
                    else if (String.IsNullOrEmpty(paramItemAmount2))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品価格２(税込)が指定されていません</b></font>";
                    }
                }
                else if (!String.IsNullOrEmpty(paramItemAmount2))
                {
                    if (String.IsNullOrEmpty(paramItemName2))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品名２が指定されていません</b></font>";
                    }
                    else if (String.IsNullOrEmpty(paramItemCount2))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>数量２(税込)が指定されていません</b></font>";
                    }
                }
            }

            // 商品３の整合性チェック
            if (String.IsNullOrEmpty(errorMessage.Text))
            {
                if (!String.IsNullOrEmpty(paramItemName3))
                {
                    if (String.IsNullOrEmpty(paramItemCount3))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>数量３が指定されていません</b></font>";
                    }
                    else if (String.IsNullOrEmpty(paramItemAmount3))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品価格３(税込)が指定されていません</b></font>";
                    }
                }
                else if (!String.IsNullOrEmpty(paramItemCount3))
                {
                    if (String.IsNullOrEmpty(paramItemName3))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品名３が指定されていません</b></font>";
                    }
                    else if (String.IsNullOrEmpty(paramItemAmount3))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品価格３(税込)が指定されていません</b></font>";
                    }
                }
                else if (!String.IsNullOrEmpty(paramItemAmount3))
                {
                    if (String.IsNullOrEmpty(paramItemName3))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品名３が指定されていません</b></font>";
                    }
                    else if (String.IsNullOrEmpty(paramItemCount3))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>数量３(税込)が指定されていません</b></font>";
                    }
                }
            }

            // 商品４の整合性チェック
            if (String.IsNullOrEmpty(errorMessage.Text))
            {
                if (!String.IsNullOrEmpty(paramItemName4))
                {
                    if (String.IsNullOrEmpty(paramItemCount4))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>数量４が指定されていません</b></font>";
                    }
                    else if (String.IsNullOrEmpty(paramItemAmount4))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品価格４(税込)が指定されていません</b></font>";
                    }
                }
                else if (!String.IsNullOrEmpty(paramItemCount4))
                {
                    if (String.IsNullOrEmpty(paramItemName4))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品名４が指定されていません</b></font>";
                    }
                    else if (String.IsNullOrEmpty(paramItemAmount4))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品価格４(税込)が指定されていません</b></font>";
                    }
                }
                else if (!String.IsNullOrEmpty(paramItemAmount4))
                {
                    if (String.IsNullOrEmpty(paramItemName4))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品名４が指定されていません</b></font>";
                    }
                    else if (String.IsNullOrEmpty(paramItemCount4))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>数量４(税込)が指定されていません</b></font>";
                    }
                }
            }

            // 商品５の整合性チェック
            if (String.IsNullOrEmpty(errorMessage.Text))
            {
                if (!String.IsNullOrEmpty(paramItemName5))
                {
                    if (String.IsNullOrEmpty(paramItemCount5))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>数量５が指定されていません</b></font>";
                    }
                    else if (String.IsNullOrEmpty(paramItemAmount5))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品価格５(税込)が指定されていません</b></font>";
                    }
                }
                else if (!String.IsNullOrEmpty(paramItemCount5))
                {
                    if (String.IsNullOrEmpty(paramItemName5))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品名５が指定されていません</b></font>";
                    }
                    else if (String.IsNullOrEmpty(paramItemAmount5))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品価格５(税込)が指定されていません</b></font>";
                    }
                }
                else if (!String.IsNullOrEmpty(paramItemAmount5))
                {
                    if (String.IsNullOrEmpty(paramItemName5))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>商品名５が指定されていません</b></font>";
                    }
                    else if (String.IsNullOrEmpty(paramItemCount5))
                    {
                        errorMessage.Text = "<font color='#ff0000'><b>数量５(税込)が指定されていません</b></font>";
                    }
                }
            }


            // エラー時の処理
            if (String.IsNullOrEmpty(errorMessage.Text) == false)
            {
                return;
            }

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 画面入力値を実行クラスに渡すためにセッションに設定します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Session["orderId"] = paramOrderId;
            Session["oricoOrderNo"] = paramOricoOrderNo;
            Session["userNo"] = paramUserNo;
            Session["shippingZipCode"] = paramShippingZipCode;
            Session["handlingContractNo"] = paramHandlingContractNo;
            Session["contractDocumentKbn"] = paramContractDocumentKbn;
            Session["webDescriptionId"] = paramWebDescriptionId;
            Session["itemName1"] = paramItemName1;
            Session["itemCount1"] = paramItemCount1;
            Session["itemAmount1"] = paramItemAmount1;
            Session["itemName2"] = paramItemName2;
            Session["itemCount2"] = paramItemCount2;
            Session["itemAmount2"] = paramItemAmount2;
            Session["itemName3"] = paramItemName3;
            Session["itemCount3"] = paramItemCount3;
            Session["itemAmount3"] = paramItemAmount3;
            Session["itemName4"] = paramItemName4;
            Session["itemCount4"] = paramItemCount4;
            Session["itemAmount4"] = paramItemAmount4;
            Session["itemName5"] = paramItemName5;
            Session["itemCount5"] = paramItemCount5;
            Session["itemAmount5"] = paramItemAmount5;
            Session["totalItemAmount"] = paramTotalItemAmount;
            Session["totalCarriage"] = paramTotalCarriage;
            Session["amount"] = paramAmount;
            Session["deposit"] = paramDeposit;

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 実行＆結果画面を表示します
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Response.Redirect("./AuthorizeExec.aspx", true);
        }

    }
}
