﻿using System;
using System.Web.UI;

namespace web.paynowid
{
    public partial class AccountEntry : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
        }

        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 会員IDの取得
            String accountId = AccountId.Text;
            // 入会年月日の取得
            String createDate = CreateDate.Text;
            // 入会処理区分の取得
            String entryKbn = EntryKbn.SelectedValue;

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 入力をチェックします
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 会員ID
            if (String.IsNullOrEmpty(accountId))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：会員IDが指定されていません</b></font>";
                return;
            }
            // 入会処理区分
            if (string.IsNullOrEmpty(entryKbn))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：入会処理区分 が指定されていません</b></font>";
                return;
            }
            if (entryKbn != "1" && entryKbn != "2")
            {
                errorMessage.Text = "<font color='#ff0000'><b>不正な入会処理区分です </b></font>";
                return;
            }

            // 画面入力値を実行クラスに渡すためにセッションに設定します。
            Session["accountId"] = accountId;
            Session["createDate"] = (!String.IsNullOrEmpty(createDate)) ? createDate : null;
            Session["entryKbn"] = entryKbn;

            // 実行＆結果画面を表示します
            Response.Redirect("./AccountEntryExec.aspx", true);
        }

        
    }
}
