﻿using System;
using System.Web.UI;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace web.paynowid
{
    public partial class AccountEntryExec : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Transaction transaction;

            string entryKbn = (Session["entryKbn"] != null) ? Session["entryKbn"].ToString() : "";
            string accountId = (Session["accountId"] != null) ? Session["accountId"].ToString() : null;
            string createDate = (Session["createDate"] != null) ? Session["createDate"].ToString() : null;

            if (entryKbn == "1")
            {
                // 新規入会 //
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 要求DTOを生成し、値を設定します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                var reqDto = new AccountAddRequestDto
                    {
                        AccountId = accountId,
                        CreateDate = createDate
                    };

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // コマンドを実行し、応答DTOを取得します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                transaction = new Transaction();
                var resDto = (AccountAddResponseDto)transaction.Execute(reqDto);

                if (resDto.PayNowIdResponse != null)
                {
                    PayNowIdProcId.Text = resDto.PayNowIdResponse.ProcessId;
                    PayNowIdStatus.Text = resDto.PayNowIdResponse.Status;
                }
                VResultCode.Text = resDto.VResultCode;
                MErrMsg.Text = resDto.MerrMsg;
            }
            else
            {
                // 再入会 //

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 要求DTOを生成し、値を設定します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                var reqDto = new AccountRestoreRequestDto
                {
                    AccountId = accountId,
                    CreateDate = createDate
                };

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // コマンドを実行し、応答DTOを取得します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                transaction = new Transaction();
                var resDto = (AccountRestoreResponseDto)transaction.Execute(reqDto);

                if (resDto.PayNowIdResponse != null)
                {
                    PayNowIdProcId.Text = resDto.PayNowIdResponse.ProcessId;
                    PayNowIdStatus.Text = resDto.PayNowIdResponse.Status;
                }
                VResultCode.Text = resDto.VResultCode;
                MErrMsg.Text = resDto.MerrMsg;
            }
        }
    }
}
