﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="CardManage.aspx.cs"
    Inherits="web.paynowid.CardManage" %>

<!DOCTYPE html>
<html lang="ja">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>VeriTrans 4G - 会員カード管理サンプル画面</title>
    <link href="../css/style.css" rel="stylesheet" type="text/css" />
    <script language="JavaScript" type="text/javascript">
        function initializeVal() {
            document.getElementById('CardNumber').value = "";
            document.getElementById('Cc-exp').value = "";
        }

        document.addEventListener('DOMContentLoaded', function () {
            document.getElementById('SubmitTokenBtn').addEventListener('click', function () {
                var data = {};
                data.token_api_key = document.getElementById('TokenApiKey').innerText;
                if (document.getElementById('CardNumber')) {
                    data.card_number = document.getElementById('CardNumber').value;
                }
                if (document.getElementById('Cc-exp')) {
                    data.card_expire = document.getElementById('Cc-exp').value;
                }
                data.lang = "ja";

                var url = document.getElementById('TokenApiUrl').innerText;

                var xhr = new XMLHttpRequest();
                xhr.open('POST', url, true);
                xhr.setRequestHeader('Accept', 'application/json');
                xhr.setRequestHeader('Content-Type', 'application/json; charset=utf-8');
                xhr.addEventListener('loadend', function () {
                    if (xhr.status === 0) {
                        alert("トークンサーバーとの接続に失敗しました");
                        return;
                    }
                    var response = JSON.parse(xhr.response);
                    if (xhr.status == 200) {
                        initializeVal();
                        document.getElementById('Token').value = response.token;
                        document.getElementById('SubmitTokenBtnHidden').click();
                    }
                    else {
                        alert(response.message);
                    }

                });
                xhr.send(JSON.stringify(data));
            });
        });
    </script>
</head>
<body>
    <img alt='Paymentロゴ' src='../WEB-IMG/VeriTrans_Payment.png' /><hr />
    <div class="system-message">
        <span style="font-size: small;">
            本画面はVeriTrans4G 会員カード管理のサンプル画面です。<br />
            お客様ECサイトとVeriTrans4Gとを連動させるための参考、例としてご利用ください。<br />
            また、本画面では基本的なパラメータのみを表示させていますので、開発ガイドも合わせてご参照ください。<br />
        </span>
    </div>
    <asp:Label runat="server" ID="ErrorMessage"></asp:Label>
    <div class="lhtitle">会員カード管理</div>
    <form id="Form1" name="FORM_PAY_NOW_ID" method="post" runat="server">
        <table style="border-width: 0; padding: 0; border-collapse: collapse;">
            <tr>
                <td class="thl" colspan="2">カード情報</td>
            </tr>
            <tr>
                <td class="ititlecommon">会員ID</td>
                <td class="ivaluecommon">
                    <asp:TextBox runat="server" size="50" MaxLength="100" ID="AccountId"></asp:TextBox>
                    <asp:Button runat="server" Text="カード情報取得" ID="GetCardInfo" Onclick="GetCardInfo_Click" OnClientClick="initializeVal()" />
                </td>
            </tr>
            <tr>
                <td class="ititlecommon">カード選択</td>
                <td class="ivaluecommon">
                    <asp:DropDownList runat="server" ID="CardSelect"/>
                    <asp:Button runat="server" Text="削除" ID="CardDelete" Onclick="DeleteCardInfo_Click" OnClientClick="initializeVal()" />
                </td>
            </tr>
                <tr>
              <td class="ititlecommon">クレジットカード番号</td>
              <td class="ivaluecommon">
                  <input id="CardNumber" type="tel" x-autocompletetype="cc-number" autocompletetype="cc-number" autocorrect="off" spellcheck="off" autocapitalize="off" maxlength="19" size="19" />
                  <span style="font-size: small; color: red;">&nbsp;(カード選択時に入力した場合、カード番号の変更扱い)</span>
              </td>
            </tr>
            <tr>
              <td class="ititlecommon">有効期限</td>
              <td class="ivaluecommon">
                  <input id="Cc-exp" type="tel" x-autocompletetype="off" autocompletetype="off" autocorrect="off" spellcheck="off" autocapitalize="off" placeholder="MM/YY" maxlength="5" size="5" />
                  &nbsp;&nbsp;<span style="font-size: small; color: red;">※形式：MM/YY
                  <br>&nbsp;(カード選択時に入力した場合、有効期限の延長扱い)</span>
              </td>
            </tr>
            <tr>
                <td class="thlToken" colspan="2">
                    MDKトークン設定情報
                </td>
            </tr>
            <tr>
                <td class="ititlecommon">トークンAPIキー</td>
                <td class="ivaluecommon">
                    <asp:Label runat="server" ID="TokenApiKey"></asp:Label>
                </td>
            </tr>
            <tr>
                <td class="ititlecommon">トークンAPI URL</td>
                <td class="ivaluecommon">
                    <asp:Label runat="server" ID="TokenApiUrl"></asp:Label>
                </td>
            </tr>
            <tr><td colspan="2">&nbsp;</td></tr>
            <tr>
                <td colspan="2">
                    <button id="SubmitTokenBtn" onclick="return false;">実行</button>
                    &nbsp;&nbsp;<span style="font-size: small; color: red">※2回以上クリックしないでください。</span>
                    <asp:Button ID="SubmitTokenBtnHidden" OnClick="AddOrUpdateCardInfo_Click" runat="server" style="visibility:hidden" />
                </td>
            </tr>
        </table>
        <asp:HiddenField ID="Token" runat="server" />
    </form>
    <a href="../PayNowIdMenu.aspx">PayNowIDサンプルのトップメニューへ戻る</a>&nbsp;&nbsp;
    <hr />
    <img alt="VeriTransロゴ" src="../WEB-IMG/VeriTransLogo_WH.png" />&nbsp; Copyright &copy;
    VeriTrans Inc. All rights reserved
</body>
</html>
