﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="EntryAndCard.aspx.cs" Inherits="web.paynowid.EntryAndCard" %>

<!DOCTYPE html>
<html lang="ja">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>VeriTrans 4G - 決済＋会員入会サンプル画面</title>
    <link href="../css/style.css" rel="stylesheet" type="text/css" />

    <script language="JavaScript" type="text/javascript">
        function jpoChk(jpoObj) {
            var val = jpoObj.value;
            if (val.length == 1) {
                if (isNaN(val) == false) {
                    jpoObj.value = "0" + jpoObj.value;
                }
            }
        }

        function initializeVal() {
            document.getElementById('CardNumber').value = "";
            document.getElementById('Cc-exp').value = "";
            document.getElementById('Cc-csc').value = "";
        }

        document.addEventListener('DOMContentLoaded', function () {
            document.getElementById('SubmitTokenBtn').addEventListener('click', function () {
                var data = {};
                data.token_api_key = document.getElementById('TokenApiKey').innerText;
                if (document.getElementById('CardNumber')) {
                    data.card_number = document.getElementById('CardNumber').value;
                }
                if (document.getElementById('Cc-exp')) {
                    data.card_expire = document.getElementById('Cc-exp').value;
                }
                if (document.getElementById('Cc-csc')) {
                    data.security_code = document.getElementById('Cc-csc').value;
                }
                data.lang = "ja";

                var url = document.getElementById('TokenApiUrl').innerText;

                var xhr = new XMLHttpRequest();
                xhr.open('POST', url, true);
                xhr.setRequestHeader('Accept', 'application/json');
                xhr.setRequestHeader('Content-Type', 'application/json; charset=utf-8');
                xhr.addEventListener('loadend', function () {
                    if (xhr.status === 0) {
                        alert("トークンサーバーとの接続に失敗しました");
                        return;
                    }
                    var response = JSON.parse(xhr.response);
                    if (xhr.status == 200) {
                        initializeVal();
                        document.getElementById('Token').value = response.token;
                        document.getElementById('SubmitTokenBtnHidden').click();
                    } else {
                        alert(response.message);
                    }

                });
                xhr.send(JSON.stringify(data));
            });
        });
    </script>

</head>
<body>
    <img alt='Paymentロゴ' src='../WEB-IMG/VeriTrans_Payment.png' /><hr />
    <div class="system-message">
        <span style="font-size: small;">
            本画面はVeriTrans4G 決済＋会員入会のサンプル画面です。<br />
            お客様ECサイトとVeriTrans4Gとを連動させるための参考、例としてご利用ください。<br />
            また、本画面では基本的なパラメータのみを表示させていますので、開発ガイドも合わせてご参照ください。<br />
        </span>
    </div>
    <asp:Label runat="server" ID="ErrorMessage"></asp:Label>
    <div class="lhtitle">
        決済＋会員入会</div>
    <form id="Form1" name="FORM_PAY_NOW_ID" method="post" runat="server">
    <table style="border-width: 0; padding: 0; border-collapse: collapse;">
        <tr>
            <td class="thl" colspan="2">
                決済情報（カード決済）
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                取引ID
            </td>
            <td class="ivaluecommon">
                <asp:Label runat="server" ID="OrderId"></asp:Label>
                &nbsp;&nbsp;
                <asp:Button runat="server" Text="取引ID更新" OnClick="btnReplaceOrderId_Click" OnClientClick="initializeVal()" />
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                金額
            </td>
            <td class="ivaluecommon">
                <asp:TextBox runat="server" ID="Amount" MaxLength="8" size="9"></asp:TextBox>
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                与信方法
            </td>
            <td class="ivaluecommon">
                <asp:DropDownList ID="WithCapture" runat="server">
                    <asp:ListItem Value="0">与信のみ(与信成功後に売上処理を行う必要があります)</asp:ListItem>
                    <asp:ListItem Value="1">与信売上(与信と同時に売上処理も行います)</asp:ListItem>
                </asp:DropDownList>
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                クレジットカード番号
            </td>
            <td class="ivaluecommon">
                <input id="CardNumber" type="tel" x-autocompletetype="cc-number" autocompletetype="cc-number" autocorrect="off" spellcheck="off" autocapitalize="off" maxlength="19" size="19" />
                <span style="font-size: small; color: red;">&nbsp;(カード選択時に入力した場合、カード番号の変更扱い)</span>
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                有効期限
            </td>
            <td class="ivaluecommon">
                <input id="Cc-exp" type="tel" x-autocompletetype="off" autocompletetype="off" autocorrect="off" spellcheck="off" autocapitalize="off" placeholder="MM/YY" maxlength="5" size="5" />
                  &nbsp;&nbsp;<span style="font-size: small; color: red;">※形式：MM/YY</span>
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                支払方法
            </td>
            <td class="ivaluecommon">
                <asp:DropDownList ID="Jpo1" runat="server">
                    <asp:ListItem Value="10">一括払い(支払回数の設定は不要)</asp:ListItem>
                    <asp:ListItem Value="61">分割払い(支払回数を設定してください)</asp:ListItem>
                    <asp:ListItem Value="80">リボ払い(支払回数の設定は不要)</asp:ListItem>
                </asp:DropDownList>
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                支払回数
            </td>
            <td class="ivaluecommon">
                <asp:TextBox ID="Jpo2" runat="server" MaxLength="2" size="3" onBlur="jpoChk(this);" />&nbsp;&nbsp;
                <font size="2" color="red">※一桁の場合は数値の前に&quot;0&quot;をつけてください。&nbsp;&nbsp;例：01</font>
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                セキュリティコード
            </td>
            <td class="ivaluecommon">
                <input id="Cc-csc" type="tel" autocomplete="off" autocorrect="off" spellcheck="off" autocapitalize="off" maxlength="4" size="4">
                &nbsp;&nbsp;<span style="font-size: small; color: red;">※必要な場合は入力してください。</span>
            </td>
        </tr>
        <tr>
            <td class="thlToken" colspan="2">
                MDKトークン設定情報
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">トークンAPIキー</td>
            <td class="ivaluecommon">
                <asp:Label runat="server" ID="TokenApiKey"></asp:Label>
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">トークンAPI URL</td>
            <td class="ivaluecommon">
                <asp:Label runat="server" ID="TokenApiUrl"></asp:Label>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                &nbsp;
            </td>
        </tr>
        <tr>
            <td colspan="2">
                &nbsp;
            </td>
        </tr>
        <tr>
            <td class="thl" colspan="2">
                入会情報
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                会員ID
            </td>
            <td class="ivaluecommon">
                <asp:TextBox type="text" size="50" name="accountId" MaxLength="100" runat="server"
                    ID="AccountId" />
            </td>
        </tr>
        <tr>
            <td colspan="2">
                &nbsp;
            </td>
        </tr>
        <tr>
            <td colspan="2">
                &nbsp;
            </td>
        </tr>
        <tr>
            <td class="thl" colspan="2">
                継続課金情報&nbsp;&nbsp;
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                課金グループID
            </td>
            <td class="ivaluecommon">
                <asp:TextBox runat="server" size="30" MaxLength="24" ID="GroupId"></asp:TextBox>
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                課金開始日
            </td>
            <td class="ivaluecommon">
                <asp:TextBox runat="server" size="8" MaxLength="8" ID="StartDate"></asp:TextBox>
                &nbsp;&nbsp;<font size="2" color="red">※形式:YYYYMMDD</font>
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                課金終了日
            </td>
            <td class="ivaluecommon">
                <asp:TextBox runat="server" size="8" MaxLength="8" ID="EndDate"></asp:TextBox>
                &nbsp;&nbsp;<font size="2" color="red">※形式:YYYYMMDD</font><br />
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                都度／初回課金金額
            </td>
            <td class="ivaluecommon">
                <asp:TextBox runat="server" size="12" MaxLength="12" ID="OneTimeAmount"></asp:TextBox>
            </td>
        </tr>
        <tr>
            <td class="ititlecommon">
                継続課金金額
            </td>
            <td class="ivaluecommon">
                <asp:TextBox runat="server" size="12" MaxLength="12" ID="RecurringAmount"></asp:TextBox>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <font size="2" color="red">※継続課金情報は決済サービス種別がカード決済の場合のみ設定可能です。<br />
                    &nbsp;&nbsp;入会費や月額課金が発生するサービス等に加入する際に設定ください。</font>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                &nbsp;
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <button id="SubmitTokenBtn" onclick="return false;">実行</button>
                &nbsp;&nbsp;<span style="font-size: small; color: red">※2回以上クリックしないでください。</span>
                <asp:Button ID="SubmitTokenBtnHidden" OnClick="Submit_Click" runat="server" style="visibility:hidden" />
            </td>
        </tr>
    </table>
    <asp:HiddenField ID="Token" runat="server" />
    </form>
    <a href="../PayNowIdMenu.aspx">PayNowIDサンプルのトップメニューへ戻る</a>&nbsp;&nbsp;
    <hr />
    <img alt="VeriTransロゴ" src="../WEB-IMG/VeriTransLogo_WH.png" />&nbsp; Copyright &copy;
    VeriTrans Inc. All rights reserved
</body>
</html>
