﻿using System;
using jp.veritrans.tercerog.mdk;
using MdkSampleDotNet;

namespace web.paynowid
{
    public partial class EntryAndCard : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                OrderId.Text = "dummy" + Utils.CurrentTimeMillis();

                Amount.Text = Request.QueryString["price"];

                if (Session["warning"] != null)
                {
                    ErrorMessage.Text = Session["warning"].ToString();
                    Session.Remove("warning");
                }
                TokenApiKey.Text = Utils.getXPath(SampleConstants.TOKEN_API_KEY);
                TokenApiUrl.Text = Utils.getXPath(SampleConstants.TOKEN_API_URL);
                if (String.IsNullOrEmpty(TokenApiUrl.Text))
                {
                    var uri = new Uri(MerchantContext.Config.GetValue(MerchantConfig.SERVER_URL));
                    TokenApiUrl.Text = uri.ToString().TrimEnd('/') + "/4gtoken";
                }
            }
        }

        protected void btnReplaceOrderId_Click(object sender, EventArgs e)
        {
            OrderId.Text = "dummy" + Utils.CurrentTimeMillis();
        }

        protected void Submit_Click(object sender, EventArgs e)
        {
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 与信方法の取得
            String withCapture = WithCapture.SelectedValue;
            // 取引IDの取得
            String orderId = OrderId.Text;
            // 金額の取得
            String amount = Amount.Text;
            // トークンの取得
            String token = Token.Value;
            // 支払方法の取得
            String jpo1 = Jpo1.SelectedValue;
            // 支払回数の取得
            String jpo2 = Jpo2.Text;
            // 会員IDの取得
            String accountId = AccountId.Text;
            // 課金グループIDの取得
            String groupId = GroupId.Text;
            // 課金開始日の取得
            String startDate = StartDate.Text;
            // 課金終了日の取得
            String endDate = EndDate.Text;
            // 都度／初回課金金額の取得
            String oneTimeAmount = OneTimeAmount.Text;
            // 継続課金金額の取得
            String recurringAmount = RecurringAmount.Text;

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 入力をチェックします。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            if (String.IsNullOrEmpty(orderId))
            {
                ErrorMessage.Text = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font>";
                return;
            }
            if (String.IsNullOrEmpty(amount))
            {
                ErrorMessage.Text = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font>";
                return;
            }

            Session["orderId"] = orderId;
            Session["amount"] = amount;
            Session["token"] = token;
            Session["withCapture"] = (!String.IsNullOrEmpty(withCapture)) ? withCapture : null;
            Session["jpo1"] = (!String.IsNullOrEmpty(jpo1)) ? jpo1 : null;
            Session["jpo2"] = (!String.IsNullOrEmpty(jpo2)) ? jpo2 : null;
            Session["accountId"] = (!String.IsNullOrEmpty(accountId)) ? accountId : null;
            Session["groupId"] = (!String.IsNullOrEmpty(groupId)) ? groupId : null;
            Session["startDate"] = (!String.IsNullOrEmpty(startDate)) ? startDate : null;
            Session["endDate"] = (!String.IsNullOrEmpty(endDate)) ? endDate : null;
            Session["oneTimeAmount"] = (!String.IsNullOrEmpty(oneTimeAmount)) ? oneTimeAmount : null;
            Session["recurringAmount"] = (!String.IsNullOrEmpty(recurringAmount)) ? recurringAmount : null;

            // 実行＆結果画面を表示します
            Response.Redirect("./EntryAndCardExec.aspx", true);

        }
    }
}
