﻿using System;
using MdkSampleDotNet;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace web.paynowid
{
    public partial class MpiAuthorize : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                OrderId.Text = "dummy" + Utils.CurrentTimeMillis();

                Amount.Text = Request.QueryString["price"];

                if (Session["warning"] != null)
                {
                    ErrorMessage.Text = Session["warning"].ToString();
                    Session.Remove("warning");
                }
            }
        }

        protected void btnReplaceOrderId_Click(object sender, EventArgs e)
        {
            OrderId.Text = "dummy" + Utils.CurrentTimeMillis();
        }

        protected void Next_Click(object sender, EventArgs e)
        {
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 会員ID
            String accountId = AccountId.Text;
            // 取引ID
            String orderId = OrderId.Text;
            // 金額
            String amount = Amount.Text;
            // 与信方法
            String withCapture = WithCapture.SelectedValue;
            // 決済種別
            String paymentMode = PaymentMode.SelectedValue;

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 入力をチェックします。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++

            if (String.IsNullOrEmpty(orderId))
            {
                ErrorMessage.Text = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font>";
                return;
            }
            if (String.IsNullOrEmpty(amount))
            {
                ErrorMessage.Text = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font>";
                return;
            }
            if (String.IsNullOrEmpty(accountId))
            {
                ErrorMessage.Text = "<font color='#ff0000'><b>必須項目：会員IDが指定されていません</b></font>";
                return;
            }

            // Dtoの生成
            var reqDto = new CardInfoGetRequestDto {AccountId = accountId};
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // コマンドを実行し、応答DTOを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            var tran = new Transaction();
            var resDto = (CardInfoGetResponseDto)tran.Execute(reqDto);

            // 処理結果を取得する
            String mStatus = resDto.Mstatus;

            if ("success" == mStatus)
            {
                // 成功の場合、カード選択画面に遷移
                // 取引ID
                Session["orderId"] = orderId;
                // 会員ID
                Session["accountId"] = accountId;
                // 金額
                Session["amount"] = amount;
                // 与信方法
                Session["withCapture"] = (!String.IsNullOrEmpty(withCapture)) ? withCapture : null;
                // 決済種別
                Session["paymentMode"] = (!String.IsNullOrEmpty(paymentMode)) ? paymentMode : null;

                Response.Redirect("./MpiAuthorizeSelect.aspx", true);
            }
            else
            {
                // それ以外の場合、決済結果画面に遷移

                // 会員ID
                Session["accountId"] = accountId;
                // 金額
                Session["amount"] = amount;
                // 与信方法
                Session["withCapture"] = (!String.IsNullOrEmpty(withCapture)) ? withCapture : null;
                // 決済種別
                Session["paymentMode"] = (!String.IsNullOrEmpty(paymentMode)) ? paymentMode : null;

                // 取引ID
                Session["orderId"] = orderId;
                // 取引ステータス
                Session["mStatus"] = mStatus;
                // PayNowIDステータス
                if (resDto.PayNowIdResponse != null)
                {
                    Session["payNowIdStatus"] = resDto.PayNowIdResponse.Status;
                }
                // 結果コード
                Session["vResultCode"] = resDto.VResultCode;
                // 結果メッセージ
                Session["mErrMsg"] = resDto.MerrMsg;

                Response.Redirect("./MpiAuthorizeExec.aspx", true);
            }
        }
    }
}
