﻿using System;
using MdkSampleDotNet;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace web.paynowid
{
    public partial class MpiSearchExec : System.Web.UI.Page
    {
        protected String AuthorizeTypeStr = "";

        /// <summary>
        /// リダイレクトされたサーチ処理。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 取引ID（ブラウザにリダイレクトされたリクエストから取得）
            String orderId = Request.Form["orderId"];
            // リクエストID（ブラウザにリダイレクトされたリクエストから取得）
            String requestId = Request.Form["requestId"];

            if ("1".Equals(Session["reAuthorizeFlg"]))
            {
                AuthorizeTypeStr = "再";
            }
            var paramPaymentMode = (String)Session["paramPaymentMode"];


            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 要求DTOを生成し、値を設定します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            var requestDto = new SearchRequestDto
                {
                    RequestId = requestId, 
                    NewerFlag = SampleConstants.MDK_PARAM_FALSE
                };


            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // コマンドを実行し、応答DTOを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            var tran = new Transaction();
            var responseData = (SearchResponseDto)tran.Execute(requestDto);


            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 結果画面に表示します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            OrderId.Text = orderId;
            Mstatus.Text = responseData.Mstatus;
            VResultCode.Text = responseData.VResultCode;
            MerrMsg.Text = responseData.MerrMsg;

            /**
             * 取引情報の取得と確認
             */
            TransactionInfo[] transactionInfo = responseData.OrderInfos.OrderInfo[0].TransactionInfos.TransactionInfo;

            /**
             * 検索結果の中から、最新のMPI取引状態、およびCARD取引状態を取得します。
             */
            String mpiStatus = "";
            String mpiVResultCode = "";
            String mpiTxnId = "";
            String cardStatus = "";
            String cardVResultCode = "";
            String cardTxnId = "";
            foreach (TransactionInfo info in transactionInfo)
            {
                String mStatus = info.Mstatus;
                String vResultCode = info.VResultCode;
                String txnId = info.TxnId;
                ProperTransactionInfo properInfo = info.ProperTransactionInfo;
                // 取引種別の取得
                String txnKind = "";
                if (properInfo != null)
                {
                    txnKind = properInfo.TxnKind;
                }

                // MPI～カード決済までが実行された場合
                // このタイミングでリクエストIDによる検索を実行すると
                // txnKindが"mpi"と"card"のレコードがそれぞれ１件取得できる

                // MPI認証結果を取得(複数件の場合最新をチェックする)
                if (String.IsNullOrEmpty(txnId) == false && "mpi".Equals(txnKind))
                {
                    if (String.IsNullOrEmpty(mpiTxnId) || Convert.ToInt64(txnId) > Convert.ToInt64(mpiTxnId))
                    {
                        mpiStatus = mStatus;
                        mpiVResultCode = vResultCode;
                        mpiTxnId = txnId;
                    }
                }
                // カード決済結果を取得（複数件の場合最新をチェックする）
                if (String.IsNullOrEmpty(txnId) == false && "card".Equals(txnKind))
                {
                    if (String.IsNullOrEmpty(cardTxnId) || Convert.ToInt64(txnId) > Convert.ToInt64(cardTxnId))
                    {
                        cardStatus = mStatus;
                        cardVResultCode = vResultCode;
                        cardTxnId = txnId;
                    }
                }
            }

            // 基本は本人認証の結果
            Mstatus.Text = mpiStatus;
            VResultCode.Text = mpiVResultCode;

            if (SampleConstants.TXN_SUCCESS_CODE.Equals(mpiVResultCode))
            {
                if ("1".Equals(paramPaymentMode))
                {

                    Mstatus.Text = cardStatus;
                    VResultCode.Text = cardVResultCode;
                }
            }
        }
    }
}
