﻿using System;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace web.paynowid
{
    public partial class RecurringExec : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            var chargeMode = (Session["chargeMode"] != null ? Session["chargeMode"].ToString() : "");
            var accountId = (Session["accountId"] != null ? Session["accountId"].ToString() : null);
            var groupId = (Session["groupId"] != null ? Session["groupId"].ToString() : null);
            var startDate = (Session["startDate"] != null ? Session["startDate"].ToString() : null);
            var endDate = (Session["endDate"] != null ? Session["endDate"].ToString() : null);
            var oneTimeAmount = (Session["oneTimeAmount"] != null ? Session["oneTimeAmount"].ToString() : null);
            var amount = (Session["amount"] != null ? Session["amount"].ToString() : null);
            var cardSelect = (Session["cardSelect"] != null ? Session["cardSelect"].ToString() : null);
            var token = (Session["token"] != null ? Session["token"].ToString() : null);


            AbstractPayNowIdRequestDto reqDto;

            if (chargeMode == "1")
            {
                // 新規課金開始 //
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 要求DTOを生成し、値を設定します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                reqDto = new RecurringAddRequestDto
                {
                    AccountId = accountId, // 会員ID設定
                    GroupId = groupId, // 課金グループID設定
                };

                if(!string.IsNullOrEmpty(startDate)) reqDto.StartDate = startDate; // 課金開始日設定
                if(!string.IsNullOrEmpty(endDate)) reqDto.EndDate = endDate; // 課金終了日設定
                if(!string.IsNullOrEmpty(oneTimeAmount)) reqDto.OneTimeAmount = oneTimeAmount; // 都度／初回課金金額設定
                if(!string.IsNullOrEmpty(amount)) reqDto.Amount = amount; // 継続課金金額設定

                if (!string.IsNullOrEmpty(cardSelect))
                {
                    reqDto.CardId = cardSelect; // カードID
                }
                else
                {
                    reqDto.Token = token; // トークン
                }

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // コマンドを実行し、応答DTOを取得します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                var tran = new Transaction();
                var resDto = (RecurringAddResponseDto)tran.Execute(reqDto);
                if (resDto.PayNowIdResponse != null)
                {
                    PayNowIdProcId.Text = resDto.PayNowIdResponse.ProcessId;
                    PayNowIdStatus.Text = resDto.PayNowIdResponse.Status;
                }
                VResultCode.Text = resDto.VResultCode;
                MErrMsg.Text = resDto.MerrMsg;

            }
            else
            {

                // 更新 //
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 要求DTOを生成し、値を設定します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                reqDto = new RecurringUpdateRequestDto
                {
                    AccountId = accountId, // 会員ID設定
                    GroupId = groupId // 課金グループID設定
                };

                if (!string.IsNullOrEmpty(startDate)) reqDto.StartDate = startDate; // 課金開始日設定
                if (!string.IsNullOrEmpty(endDate)) reqDto.EndDate = endDate; // 課金終了日設定
                if (!string.IsNullOrEmpty(oneTimeAmount)) reqDto.OneTimeAmount = oneTimeAmount; // 都度／初回課金金額設定
                if (!string.IsNullOrEmpty(amount)) reqDto.Amount = amount; // 継続課金金額設定

                if (!string.IsNullOrEmpty(cardSelect))
                {
                    reqDto.CardId = cardSelect; // カードID
                }
                else
                {
                    reqDto.Token = token; // トークン
                }

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // コマンドを実行し、応答DTOを取得します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                var tran = new Transaction();
                var resDto = (RecurringUpdateResponseDto)tran.Execute(reqDto);
                if (resDto.PayNowIdResponse != null)
                {
                    PayNowIdProcId.Text = resDto.PayNowIdResponse.ProcessId;
                    PayNowIdStatus.Text = resDto.PayNowIdResponse.Status;
                }
                VResultCode.Text = resDto.VResultCode;
                MErrMsg.Text = resDto.MerrMsg;
            }
        }
    }
}
