﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace MdkSampleDotNet.paypal
{
    public partial class AuthorizeComplete : System.Web.UI.Page
    {
        /// <summary>
        /// 前画面で実行したgetアクションの結果を基にdoアクションを実行します。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            String paramToken = (String)Session["Token"];
            String paramPayerId = (String)Session["PayerId"];
            String paramPaymentAction = (String)Session["paramPaymentAction"];


            if ("authorize".Equals(paramPaymentAction))
            {
                // 与信のみ

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 要求DTOを生成し、値を設定します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                PaypalAuthorizeRequestDto requestData = new PaypalAuthorizeRequestDto();
                requestData.Action = "do";
                requestData.Token = paramToken;
                requestData.PayerId = paramPayerId;


                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // コマンドを実行し、応答DTOを取得します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                Transaction tran = new Transaction();
                PaypalAuthorizeResponseDto responseData = (PaypalAuthorizeResponseDto)tran.Execute(requestData);


                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 結果画面に表示します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                OrderId.Text = responseData.OrderId;
                Mstatus.Text = responseData.Mstatus;
                VResultCode.Text = responseData.VResultCode;
                MerrMsg.Text = responseData.MerrMsg;

                Token.Text = responseData.Token;
                InvoiceId.Text = responseData.InvoiceId;
                PayerId.Text = responseData.PayerId;
                Amount.Text = responseData.Amount;
                ShipName.Text = responseData.ShipName;
            }
            else
            {
                // 与信同時売上

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 要求DTOを生成し、値を設定します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                PaypalCaptureRequestDto requestData = new PaypalCaptureRequestDto();
                requestData.Action = "do";
                requestData.Token = paramToken;
                requestData.PayerId = paramPayerId;


                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // コマンドを実行し、応答DTOを取得します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                Transaction tran = new Transaction();
                PaypalCaptureResponseDto responseData = (PaypalCaptureResponseDto)tran.Execute(requestData);


                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 結果画面に表示します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                OrderId.Text = responseData.OrderId;
                Mstatus.Text = responseData.Mstatus;
                VResultCode.Text = responseData.VResultCode;
                MerrMsg.Text = responseData.MerrMsg;

                Token.Text = responseData.Token;
                InvoiceId.Text = responseData.InvoiceId;
                PayerId.Text = responseData.PayerId;
                Amount.Text = responseData.Amount;
                ShipName.Text = responseData.ShipName;
            }

            return;

        }
    }
}
