﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace MdkSampleDotNet.paypal
{
    public partial class AuthorizeConfirm : System.Web.UI.Page
    {
        /// <summary>
        /// Paypalからの遷移後に、以下の処理を行う。
        /// setアクションの結果を基にgetアクションを実行します
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // パラメータを取得します。
                // PAYPALの画面からのパラメータ文字列(GET)より取得する。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                String token = Request.QueryString["token"];
                String paramPaymentAction = (String)Session["paramPaymentAction"];

                if ("authorize".Equals(paramPaymentAction))
                {
                    // 与信のみ

                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    // 要求DTOを生成し、値を設定します。
                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    PaypalAuthorizeRequestDto requestData = new PaypalAuthorizeRequestDto();
                    requestData.Action = "get";
                    //1. PayPalからのトークンを再セット (authorize:get)
                    requestData.Token = token;


                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    // コマンドを実行し、応答DTOを取得します。
                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    Transaction tran = new Transaction();
                    PaypalAuthorizeResponseDto responseData = (PaypalAuthorizeResponseDto)tran.Execute(requestData);


                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    // 結果画面に表示します。
                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    OrderId.Text = responseData.OrderId;
                    Mstatus.Text = responseData.Mstatus;
                    VResultCode.Text = responseData.VResultCode;
                    MerrMsg.Text = responseData.MerrMsg;

                    Token.Text = responseData.Token;
                    InvoiceId.Text = responseData.InvoiceId;
                    PayerId.Text = responseData.PayerId;
                    Amount.Text = responseData.Amount;
                    ShipName.Text = responseData.ShipName;
                }
                else
                {
                    // 与信同時売上

                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    // 要求DTOを生成し、値を設定します。
                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    PaypalCaptureRequestDto requestData = new PaypalCaptureRequestDto();
                    requestData.Action = "get";
                    //1. PayPalからのトークンを再セット (authorize:get)
                    requestData.Token = token;


                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    // コマンドを実行し、応答DTOを取得します。
                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    Transaction tran = new Transaction();
                    PaypalCaptureResponseDto responseData = (PaypalCaptureResponseDto)tran.Execute(requestData);


                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    // 結果画面に表示します。
                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    OrderId.Text = responseData.OrderId;
                    Mstatus.Text = responseData.Mstatus;
                    VResultCode.Text = responseData.VResultCode;
                    MerrMsg.Text = responseData.MerrMsg;

                    Token.Text = responseData.Token;
                    InvoiceId.Text = responseData.InvoiceId;
                    PayerId.Text = responseData.PayerId;
                    Amount.Text = responseData.Amount;
                    ShipName.Text = responseData.ShipName;
                }

                return;
            }
        }

        /// <summary>
        /// getアクションの結果を基にdoアクションを実行します
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 画面入力値を実行クラスに渡すためにセッションに設定します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Session["Token"] = Token.Text;
            Session["PayerId"] = PayerId.Text;


            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 実行＆結果画面を表示します
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Response.Redirect("./AuthorizeComplete.aspx", true);
        }
    }
}
