﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using jp.veritrans.tercerog.mdk.dto;
using jp.veritrans.tercerog.mdk;


namespace MdkSampleDotNet.rakuten
{
    public partial class AuthorizeExec : System.Web.UI.Page
    {
        private Boolean displayContent = true;

        public Boolean DisplayContent {
            get { return this.displayContent; }
            set { this.displayContent = value; }
        }

        /// <summary>
        /// 初期表示イベント。
        /// パラメータを元に、GWと通信を行う。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e) {
            Response.Charset = "UTF-8";

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            String paramOrderId = (String)Session["paramOrderId"];
            String paramAmount = (String)Session["paramAmount"];
            String paramWithCapture = (String)Session["paramWithCapture"];
            String paramItemId = (String)Session["paramItemId"];
            String paramItemName = (String)Session["paramItemName"];
            String paramSuccessUrl = (String)Session["paramSuccessUrl"];
            String paramErrorUrl = (String)Session["paramErrorUrl"];
            String paramPushUrl = (String)Session["paramPushUrl"];

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 要求DTOを生成し、値を設定します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            RakutenAuthorizeRequestDto requestData = new RakutenAuthorizeRequestDto();
            requestData.OrderId = paramOrderId;
            requestData.Amount = paramAmount;
            if (MdkServiceConstants.RAKUTEN_AUTH_WITH_CAPTURE.Equals(paramWithCapture)) {
                requestData.WithCapture = "true";
            }
            requestData.ItemId = paramItemId;
            requestData.ItemName = paramItemName;
            requestData.SuccessUrl = paramSuccessUrl;
            requestData.ErrorUrl = paramErrorUrl;
            requestData.PushUrl = paramPushUrl;
            String dummyRequest = MerchantContext.Config.GetValue(MerchantConfig.DUMMY_REQUEST);
            try
            {
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // コマンドを実行し、応答DTOを取得します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                Transaction tran = new Transaction();
                RakutenAuthorizeResponseDto responseData = (RakutenAuthorizeResponseDto)tran.Execute(requestData);

                String responseContents = responseData.ResponseContents;
                if (!String.IsNullOrEmpty(responseContents)) {
                    // レスポンスコンテンツがある場合はそのまま表示します。
                    Response.ContentType = "text/html; charset=UTF-8";
                    Response.ContentEncoding = Encoding.GetEncoding("UTF-8");
                    Response.Write(responseContents);
                    displayContent = false;
                } else {
                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    // 結果画面に表示します。
                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    OrderId.Text = responseData.OrderId;
                    Mstatus.Text = responseData.Mstatus;
                    VResultCode.Text = responseData.VResultCode;
                    MerrMsg.Text = responseData.MerrMsg;
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Exception Occured !");
                Console.WriteLine("Exception Message: " + ex.Message);
                MerrMsg.Text = "Exception Occured : " + ex.Message;
            }
            Session.Clear();
        }
    }
}
