﻿using System;
using jp.veritrans.tercerog.mdk;

namespace MdkSampleDotNet.rakuten
{
    public partial class Result : System.Web.UI.Page
    {
        public String Warning { get; set; }
        /// <summary>
        /// 初期表示イベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            Response.Charset = "UTF-8";
            if (!IsPostBack)
            {
                String command = Request["command"];
                String strCommand = "";
                if ("Authorize".Equals(command))
                {
                    strCommand = "決済";
                }

                String result = Request["result"];
                String strResult = "";
                if ("SUCCESS".Equals(result))
                {
                    strResult = "完了";
                }
                else if ("CANCEL".Equals(result))
                {
                    strResult = "キャンセル";
                }
                else if ("ERROR".Equals(result))
                {
                    strResult = "エラー";
                }

                lblResult.Text = strResult;
                lblCommandResult.Text = strCommand + strResult;

                Warning = null;

                String merchantId = MerchantContext.Config.GetValue(MerchantConfig.MERCHANT_CC_ID);
                String merchantPw = MerchantContext.Config.GetValue(MerchantConfig.MERCHANT_SECRET_KEY);
                if (String.IsNullOrEmpty(merchantId) || String.IsNullOrEmpty(merchantPw))
                {
                    Warning = "<font color='#ff0000'><b>マーチャントCCIDまたはマーチャントパスワードが設定されていません。</b></font>";
                }
                else
                {
                    // パラメータ改ざんチェック
                    if (!AuthHashUtil.CheckAuthHash(Request.Params, merchantId, merchantPw))
                    {
                        Warning = "<font color='#ff0000'><b>【パラメータ改竄】パラメータ情報が改竄されています。</b></font>";
                    }
                    else
                    {
                        OrderId.Text = Request["orderId"];
                        Mstatus.Text = Request["mstatus"];
                        VResultCode.Text = Request["vResultCode"];
                        RakutenOrderId.Text = Request["rakutenOrderId"];
                    }
                }
            }
        }
    }
}
