﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using MdkSampleDotNet;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;

namespace web.recruit
{
    public partial class Authorize : System.Web.UI.Page
    {
        /// <summary>
        /// 初期表示イベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                orderId.Text = "dummy" + Utils.CurrentTimeMillis();
                amount.Text = Request.QueryString["price"];
                itemName.Text = Request.QueryString["item_name"];

                string successUrlStr = Request["successUrl"];
                if (successUrlStr == null)
                {
                    successUrlStr = MdkSampleDotNet.Utils.getXPath(MdkSampleDotNet.SampleConstants.RECRUIT_SUCCESS_URL);
                }
                string errorUrlStr = Request["errorUrl"];
                if (errorUrlStr == null)
                {
                    errorUrlStr = MdkSampleDotNet.Utils.getXPath(MdkSampleDotNet.SampleConstants.RECRUIT_ERROR_URL);
                }
                string pushUrlStr = Request["pushUrl"];
                if (pushUrlStr == null)
                {
                    pushUrlStr = MdkSampleDotNet.Utils.getXPath(MdkSampleDotNet.SampleConstants.RECRUIT_PUSH_URL);
                }

                successUrl.Text = successUrlStr;
                errorUrl.Text = errorUrlStr;
                String dummyRequest = MerchantContext.Config.GetValue(MerchantConfig.DUMMY_REQUEST);
                if ("1".Equals(dummyRequest))
                {
                    pushUrl.ReadOnly = false;
                    pushUrl.Text = pushUrlStr;
                }
                else
                {
                    pushUrl.ReadOnly = true;
                    pushUrl.Text = "";
                }

                amount.Text = Request["amount"] + Request["price"];

                withCapture.Items.Add(new ListItem("与信のみ(与信成功後に売上処理を行う必要があります)", MdkServiceConstants.RECRUIT_AUTH_ONLY));
                withCapture.Items.Add(new ListItem("与信売上(与信と同時に売上処理も行います)", MdkServiceConstants.RECRUIT_AUTH_WITH_CAPTURE));

                itemId.Text = Request["itemId"];
            }
        }

        /// <summary>
        /// 取引ID更新ボタンイベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnReplaceOrderId_Click(object sender, EventArgs e)
        {
            orderId.Text = "dummy" + Utils.CurrentTimeMillis();
        }

        /// <summary>
        /// 購入ボタンイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 取引IDの取得
            String paramOrderId = orderId.Text;
            // 金額の取得
            String paramAmount = amount.Text;
            // 与信同時売上フラグの取得
            String paramWithCapture = withCapture.SelectedValue;
            // 商品名の取得
            String paramItemName = itemName.Text;

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 入力をチェックします。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            if (String.IsNullOrEmpty(paramOrderId))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramAmount))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramItemName))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：商品名が指定されていません</b></font><br/><br/>";
                return;
            }

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 画面入力値を実行クラスに渡すためにセッションに設定します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Session["paramOrderId"] = paramOrderId;
            Session["paramAmount"] = paramAmount;
            Session["paramWithCapture"] = paramWithCapture;
            Session["paramItemId"] = itemId.Text;
            Session["paramItemName"] = itemName.Text;
            Session["paramSuccessUrl"] = successUrl.Text;
            Session["paramErrorUrl"] = errorUrl.Text;
            Session["paramPushUrl"] = pushUrl.Text;
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 実行＆結果画面を表示します
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Response.Redirect("./AuthorizeExec.aspx", true);
        }

    }
}
