﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using jp.veritrans.tercerog.mdk.dto;
using jp.veritrans.tercerog.mdk;

namespace web.recruit
{
    public partial class AuthorizeExec : System.Web.UI.Page
    {
        /// <summary>
        /// 初期表示イベント。
        /// パラメータを元に、GWと通信を行う。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            Response.Charset = "UTF-8";

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            String paramOrderId = (String)Session["paramOrderId"];
            String paramAmount = (String)Session["paramAmount"];
            String paramWithCapture = (String)Session["paramWithCapture"];
            String paramItemId = (String)Session["paramItemId"];
            String paramItemName = (String)Session["paramItemName"];
            String paramSuccessUrl = (String)Session["paramSuccessUrl"];
            String paramErrorUrl = (String)Session["paramErrorUrl"];
            String paramPushUrl = (String)Session["paramPushUrl"];

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 要求DTOを生成し、値を設定します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            RecruitAuthorizeRequestDto requestData = new RecruitAuthorizeRequestDto();
            requestData.OrderId = paramOrderId;
            requestData.Amount = paramAmount;
            if (MdkServiceConstants.RECRUIT_AUTH_WITH_CAPTURE.Equals(paramWithCapture))
            {
                requestData.WithCapture = "true";
            }
            requestData.ItemId = paramItemId;
            requestData.ItemName = paramItemName;
            requestData.SuccessUrl = paramSuccessUrl;
            requestData.ErrorUrl = paramErrorUrl;
            requestData.PushUrl = paramPushUrl;
            String dummyRequest = MerchantContext.Config.GetValue(MerchantConfig.DUMMY_REQUEST);
            try
            {
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // コマンドを実行し、応答DTOを取得します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                Transaction tran = new Transaction();
                RecruitAuthorizeResponseDto responseData = (RecruitAuthorizeResponseDto)tran.Execute(requestData);

                String redirectUrl = responseData.RedirectUrl;
                if (!String.IsNullOrEmpty(redirectUrl))
                {
                    // リダイレクトURLが取得できた場合はリダイレクトする
                    Response.Redirect(redirectUrl, true);
                }
                else
                {
                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    // 結果画面に表示します。
                    // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                    OrderId.Text = responseData.OrderId;
                    Mstatus.Text = responseData.Mstatus;
                    VResultCode.Text = responseData.VResultCode;
                    MerrMsg.Text = responseData.MerrMsg;
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Exception Occured !");
                Console.WriteLine("Exception Message: " + ex.Message);
                MerrMsg.Text = "Exception Occured : " + ex.Message;
            }
            Session.Clear();
        }
    }
}
