﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using jp.veritrans.tercerog.mdk.dto;
using jp.veritrans.tercerog.mdk;

namespace MdkSampleDotNet.saison
{
    public partial class Cancel : System.Web.UI.Page
    {
        /// <summary>
        /// 初期表示イベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            if (String.IsNullOrEmpty(Request.QueryString["orderId"]) == false)
            {
                orderId.Text = Request.QueryString["orderId"];
            }
        }

        /// <summary>
        /// 購入ボタン操作時の処理。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            String paramOrderId = orderId.Text;
            String paramCardCancelFlag = cardCancelFlag.Text;

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 入力をチェックします。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            if (String.IsNullOrEmpty(paramOrderId))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>";
                return;
            }

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 要求DTOを生成し、値を設定します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            SaisonCancelRequestDto requestData = new SaisonCancelRequestDto();
            requestData.OrderId = paramOrderId;
            requestData.CardCancelFlag = paramCardCancelFlag;

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // コマンドを実行し、応答DTOを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            Transaction tran = new Transaction();
            SaisonCancelResponseDto responseData = (SaisonCancelResponseDto)tran.Execute(requestData);

            Session["_screen"] = _screen.Value;
            Session["processName"] = "取消";

            Session["orderId"] = responseData.OrderId;
            Session["mStatus"] = responseData.Mstatus;
            Session["mErrMsg"] = responseData.MerrMsg;
            Session["vResultCode"] = responseData.VResultCode;

            Session["cardOrderId"] = responseData.CardOrderId;
            Session["cardMStatus"] = responseData.CardMstatus;
            Session["cardMErrMsg"] = responseData.CardMerrMsg;
            Session["cardVResultCode"] = responseData.CardVResultCode;
            Session["reqCardNumber"] = responseData.ReqCardNumber;
            Session["resAuthCode"] = responseData.ResAuthCode;

            Response.Redirect("./Result.aspx", true);
        }

    }
}
