﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using jp.veritrans.tercerog.mdk.dto;
using jp.veritrans.tercerog.mdk;

namespace MdkSampleDotNet.saison.mb
{
    public partial class Authorize : System.Web.UI.Page
    {
        protected string orderId = "";
        protected string amount = "";
        protected string warning = "";

        /// <summary>
        /// 表示イベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Request.QueryString["price"] != string.Empty)
            {
                orderId = "dummy" + Utils.CurrentTimeMillis();
                amount = Request.QueryString["price"];
            }
            else
            {
                amount = Request.Form["amount"];
            }

            if ("購入" == Request.Form["button"])
            {
                // 購入ボタン押下時の処理

                // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                // パラメータを取得します。
                // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                orderId = Request.Form["orderId"];
                amount = Request.Form["amount"];

                // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 入力をチェックします。
                // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                if (string.IsNullOrEmpty(orderId))
                {
                    warning = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>";
                    return;
                }
                if (string.IsNullOrEmpty(amount))
                {
                    warning = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font><br/><br/>";
                    return;
                }
                if (!IsNumber(amount))
                {
                    warning = "<font color='#ff0000'><b>金額は数値で入力しなければなりません</b></font><br/><br/>";
                    return;
                }

                string sessionId = Session.SessionID;
                Session["amount"] = amount;

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 要求DTOを生成し、値を設定します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                SaisonAuthorizeRequestDto requestData = new SaisonAuthorizeRequestDto();
                requestData.OrderId = orderId;
                requestData.SettlementMethod = "MB";
                requestData.MerchantRedirectionUri = Utils.getXPath(SampleConstants.SAISON_MERCHANT_REDIRECTION_URI_MB).Replace("sessionId", sessionId);

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // コマンドを実行し、応答DTOを取得します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                Transaction tran = new Transaction();
                SaisonAuthorizeResponseDto responseData = (SaisonAuthorizeResponseDto)tran.Execute(requestData);


                if (SampleConstants.TXN_SUCCESS_CODE == responseData.Mstatus)
                {
                    Response.Redirect(responseData.ResResponseContents);
                }
                else
                {
                    Session["_screen"] = Request.Form["_screen"];
                    Session["processName"] = "与信";
                    Session["orderId"] = responseData.OrderId;
                    Session["mStatus"] = responseData.Mstatus;
                    Session["mErrMsg"] = responseData.MerrMsg;
                    Session["vResultCode"] = responseData.VResultCode;

                    Response.Redirect("./Result.aspx", true);
                }
            }
            else if ("取引ID更新" == Request.Form["button"])
            {
                // 購入ボタン押下時の処理

                orderId = "dummy" + Utils.CurrentTimeMillis();
                amount = Request.Form["amount"];
            }
        }
        /// <summary>
        /// 引数が数値であるかを確認。
        /// </summary>
        /// <param name="strNum">確認する文字列</param>
        /// <returns>数値の場合はtrueを返す</returns>
        private bool IsNumber(string strNum)
        {
            double dNullable;

            return double.TryParse(
                strNum,
                System.Globalization.NumberStyles.Any,
                null,
                out dNullable
            );
        }
    }
}
