﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using jp.veritrans.tercerog.mdk.dto;
using jp.veritrans.tercerog.mdk;

namespace web.saison.mb
{
    public partial class Cancel : System.Web.UI.Page
    {
        protected string warning = "";

        protected string orderId = "";
        protected string cardCancelFlag = "";

        protected string _screen = "";

        /// <summary>
        /// 表示イベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {

            if ("取消" != Request.Form["button"])
            {
                // 表示時の処理

                if (string.IsNullOrEmpty(Request.QueryString["orderId"]) == false)
                {
                    orderId = Request.QueryString["orderId"];
                }
            }
            else
            {
                // 取消ボタン押下時の処理

                // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                // パラメータを取得します。
                // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                orderId = Request.Form["orderId"];
                cardCancelFlag = Request.Form["cardCancelFlag"];
                _screen = Request.Form["_screen"];

                // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 入力をチェックします。
                // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                if (String.IsNullOrEmpty(orderId))
                {
                    warning = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>";
                    return;
                }

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 要求DTOを生成し、値を設定します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                SaisonCancelRequestDto requestData = new SaisonCancelRequestDto();
                requestData.OrderId = orderId;
                requestData.CardCancelFlag = cardCancelFlag;

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // コマンドを実行し、応答DTOを取得します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                Transaction tran = new Transaction();
                SaisonCancelResponseDto responseData = (SaisonCancelResponseDto)tran.Execute(requestData);

                Session["_screen"] = _screen;
                Session["processName"] = "取消";

                Session["orderId"] = responseData.OrderId;
                Session["mStatus"] = responseData.Mstatus;
                Session["mErrMsg"] = responseData.MerrMsg;
                Session["vResultCode"] = responseData.VResultCode;

                Session["cardOrderId"] = responseData.CardOrderId;
                Session["cardMStatus"] = responseData.CardMstatus;
                Session["cardMErrMsg"] = responseData.CardMerrMsg;
                Session["cardVResultCode"] = responseData.CardVResultCode;
                Session["reqCardNumber"] = responseData.ReqCardNumber;
                Session["resAuthCode"] = responseData.ResAuthCode;

                Response.Redirect("./Result.aspx", true);
            }
        }
    }
}
