﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using jp.veritrans.tercerog.mdk.dto;
using jp.veritrans.tercerog.mdk;

namespace MdkSampleDotNet.saison.mb
{
    public partial class Capture : System.Web.UI.Page
    {
        protected string warning = "";

        protected string orderId = "";
        protected string pointBalance = "";
        protected string aqfPointBalance = "";
        protected string availableValue = "";
        protected string amount = "";
        protected string walletAmount = "";
        protected string cardAmount = "";
        protected string cardNumber = "";
        protected string cardExpire = "";
        protected string securityCode = "";
        protected string cardOrderId = "";
        protected string withCapture = "";
        protected string _screen = "";

        /// <summary>
        /// 表示イベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            if ("購入" != Request.Form["button"])
            {
                // 表示時の処理

                if (SampleConstants.TXN_SUCCESS_CODE == Request.QueryString["mstatus"])
                {
                    orderId = Request.QueryString["orderId"];
                    pointBalance = Request.QueryString["pointBalance"];
                    aqfPointBalance = Request.QueryString["aqfPointBalance"];
                    availableValue = Request.QueryString["availableValue"];
                    amount = (string)Session["amount"]; // Authorize画面で設定しておく
                }
                else
                {
                    Session["processName"] = "売上";
                    Session["orderId"] = Request.QueryString["orderId"];
                    Session["mStatus"] = Request.QueryString["mstatus"];
                    Session["vResultCode"] = Request.QueryString["vResultCode"];

                    string query = new Uri(Request.Url.AbsoluteUri).Query;
                    query = query.Replace("?", "");
                    string[] reqParams = query.Split('&');
                    for (int i = 0; i < reqParams.Length; i++)
                    {
                        string[] keyVal = reqParams[i].Split('=');

                        if (keyVal[0] == "merrMsg")
                        {
                            Session["mErrMsg"] = HttpUtility.UrlDecode(keyVal[1]);
                            break;
                        }
                    }

                    Response.Redirect("./Result.aspx", true);
                }
            }
            else
            {
                // 購入ボタン押下時の処理

                // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                // パラメータを取得します。
                // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                orderId = Request.Form["orderId"];
                pointBalance = Request.Form["pointBalance"];
                aqfPointBalance = Request.Form["aqfPointBalance"];
                availableValue = Request.Form["availableValue"];
                amount = Request.Form["amount"];
                walletAmount = Request.Form["walletAmount"];
                cardAmount = Request.Form["cardAmount"];
                cardNumber = Request.Form["cardNumber"];
                cardExpire = Request.Form["cardExpire"];
                securityCode = Request.Form["securityCode"];
                cardOrderId = Request.Form["cardOrderId"];
                withCapture = Request.Form["withCapture"];
                _screen = Request.Form["_screen"];

                // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 入力をチェックします。
                // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                if (string.IsNullOrEmpty(orderId))
                {
                    warning = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>";
                    return;
                }
                if (string.IsNullOrEmpty(amount))
                {
                    warning = "<font color='#ff0000'><b>必須項目：合計決済金額が指定されていません</b></font><br/><br/>";
                    return;
                }
                if (string.IsNullOrEmpty(walletAmount))
                {
                    warning = "<font color='#ff0000'><b>必須項目：永久不滅ウォレット決済金額が指定されていません</b></font><br/><br/>";
                    return;
                }
                if (string.IsNullOrEmpty(amount) == false && IsNumber(amount) == false)
                {
                    warning = "<font color='#ff0000'><b>合計決済金額は数値で入力しなければなりません</b></font><br/><br/>";
                    return;
                }
                if (string.IsNullOrEmpty(walletAmount) == false && IsNumber(walletAmount) == false)
                {
                    warning = "<font color='#ff0000'><b>永久不滅ウォレット決済金額は数値で入力しなければなりません</b></font><br/><br/>";
                    return;
                }
                if (string.IsNullOrEmpty(cardAmount) == false && IsNumber(cardAmount) == false)
                {
                    warning = "<font color='#ff0000'><b>カード決済金額は数値で入力しなければなりません</b></font><br/><br/>";
                    return;
                }

                Session["_screen"] = _screen;

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 要求DTOを生成し、値を設定します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                SaisonCaptureRequestDto requestData = new SaisonCaptureRequestDto();
                requestData.OrderId = orderId;
                requestData.Amount = amount;
                requestData.WalletAmount = walletAmount;
                requestData.CardAmount = cardAmount;
                requestData.CardNumber = cardNumber;
                requestData.CardExpire = cardExpire;
                requestData.SecurityCode = securityCode;
                requestData.CardOrderId = cardOrderId;
                requestData.WithCapture = withCapture;

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // コマンドを実行し、応答DTOを取得します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                Transaction tran = new Transaction();
                SaisonCaptureResponseDto responseData = (SaisonCaptureResponseDto)tran.Execute(requestData);

                Session["processName"] = "売上";
                Session["_screen"] = _screen;

                Session["orderId"] = responseData.OrderId;
                Session["mStatus"] = responseData.Mstatus;
                Session["mErrMsg"] = responseData.MerrMsg;
                Session["vResultCode"] = responseData.VResultCode;

                Session["cardOrderId"] = responseData.CardOrderId;
                Session["cardMStatus"] = responseData.CardMstatus;
                Session["cardMErrMsg"] = responseData.CardMerrMsg;
                Session["cardVResultCode"] = responseData.CardVResultCode;
                Session["reqCardNumber"] = responseData.ReqCardNumber;
                Session["resAuthCode"] = responseData.ResAuthCode;

                Response.Redirect("./Result.aspx", true);
            }
        }


        /// <summary>
        /// 引数が数値であるかを確認。
        /// </summary>
        /// <param name="strNum">確認する文字列</param>
        /// <returns>数値の場合はtrueを返す</returns>
        private bool IsNumber(string strNum)
        {
            double dNullable;

            return double.TryParse(
                strNum,
                System.Globalization.NumberStyles.Any,
                null,
                out dNullable
            );
        }

    }
}
