﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="SearchExec.aspx.cs" Inherits="web.search.linepay.SearchExec" %>
<%@ Import Namespace="jp.veritrans.tercerog.mdk.dto" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <meta http-equiv="Content-Language" content="ja" />
  <title>取引検索結果(LINE Pay)</title>
  <link href="../../css/style.css" rel="stylesheet" type="text/css"/>
</head>
<body>
  <img alt="Paymentロゴ" src="../../WEB-IMG/VeriTrans_Payment.png"/><hr/>
  <div class="system-message">
    <font size="2">
    本画面はVeriTrans4G 取引検索のサンプル画面です。<br/>
    お客様ECサイトのショッピングカートとVeriTrans4Gとを連動させるための参考、例としてご利用ください。<br/>
    </font>
  </div>

  <asp:Label ID="errorMessage" runat="server"/>

  <div class="lhtitle">検索結果（LINE Pay）</div>
  <h2>オーダー情報</h2>
  <table border="1" cellpadding="0" cellspacing="0">
    <tr bgcolor="#ffeebb">
      <th class="rititle2" nowrap colspan="2">オーダー情報</th>
    </tr>
<%
  if (order_info != null) 
  {
      String target_orderId              = order_info.OrderId;              // オーダーID
      String target_serviceTypeCd        = order_info.ServiceTypeCd;        // 決済サービスタイプ
      String target_orderStatus          = order_info.OrderStatus;          // オーダー決済状態
      String target_lastSuccessTxnType   = order_info.LastSuccessTxnType;   // 最終成功トランザクションタイプ
      String target_successDetailTxnType = order_info.SuccessDetailTxnType; // 詳細トランザクションタイプ
%>
    <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>取引ID</td>
      <td class="rivalue2" nowrap><%= target_orderId %><br/></td>
    </tr>
    <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>決済サービスタイプ</td>
      <td class="rivalue2" nowrap><%= target_serviceTypeCd %><br/></td>
    </tr>
    <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>オーダー決済状態</td>
      <td class="rivalue2" nowrap><%= target_orderStatus %><br/></td>
    </tr>
    <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>最終成功トランザクションタイプ</td>
      <td class="rivalue2" nowrap><%= target_lastSuccessTxnType %><br/></td>
    </tr>
    <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>詳細トランザクションタイプ</td>
      <td class="rivalue2" nowrap><%= target_successDetailTxnType %><br/></td>
    </tr>
    
<% 
  } 
%>   
  </table>
  <br/>
  <table border="1" cellpadding="0" cellspacing="0">
    <tr bgcolor="#ffeebb">
      <th class="rititle2" nowrap colspan="8">固有オーダー情報</th>
    </tr>
<%
  if (order_info != null) {
    ProperOrderInfo properOrderInfo = order_info.ProperOrderInfo;
    String target_withCapture       = properOrderInfo.WithCapture;       // 与信同時売上フラグ
    String target_itemId            = properOrderInfo.ItemId;            // 商品ID
    String target_itemName          = properOrderInfo.ItemName;          // 商品名
    String target_authorizeAmount   = properOrderInfo.AuthorizeAmount;   // 決済申込金額
    String target_balance           = properOrderInfo.Balance;           // 残高
    String target_authorizeDatetime = properOrderInfo.AuthorizeDatetime; // 決済申込日時
    String target_linepayOrderId    = properOrderInfo.LinepayOrderId;    // LINE PayオーダーID
%>
   <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>与信同時売上フラグ</td>
      <td class="rivalue2" nowrap><%= target_withCapture %><br/></td>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>商品名</td>
      <td class="rivalue2" nowrap><%= target_itemName %><br/></td>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>商品ID</td>
      <td class="rivalue2" nowrap><%= target_itemId %><br/></td>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>LINE PayオーダーID</td>
      <td class="rivalue2" nowrap><%= target_linepayOrderId%><br/></td>
    </tr>
    <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>申込金額</td>
      <td class="rivalue2" nowrap><%= target_authorizeAmount %><br/></td>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>残高</td>
      <td class="rivalue2" nowrap><%= target_balance %><br/></td>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>決済申込確定日時</td>
      <td class="rivalue2" nowrap><%= target_authorizeDatetime %><br/></td>
    </tr>

<%
  }
%>
  </table>
  <br/>
  <h2>トランザクション情報</h2>
  <table border="1" cellpadding="0" cellspacing="0">
    <tr bgcolor="#ffeebb">
      <th class="rititle2" nowrap colspan="6">決済トランザクション情報</th>
      <th class="rititle2" nowrap colspan="4">固有トランザクション情報</th>
    </tr>
    <tr bgcolor="#ffeebb">
      <!-- 決済トランザクション情報 -->
      <th class="rititle2" nowrap width="65">管理ID</th>
      <th class="rititle2" nowrap width="120">コマンド</th>
      <th class="rititle2" nowrap width="130">ステータスコード</th>
      <th class="rititle2" nowrap width="145">結果コード</th>
      <th class="rititle2" nowrap width="180">取引日時</th>
      <th class="rititle2" nowrap width="100">金額</th>

      <!-- 固有トランザクション情報 -->
      <th class="rititle2" nowrap width="200">LINE Payエラーコード</th>
      <th class="rititle2" nowrap width="145">詳細コマンドタイプ</th>
      <th class="rititle2" nowrap width="170">LINE Payへの要求日時</th>
      <th class="rititle2" nowrap width="185">LINE Payからの返戻日時</th>
    </tr>
<%
  if (order_info != null) {
    TransactionInfos transactionInfos = order_info.TransactionInfos;
    TransactionInfo[] transactionInfo = transactionInfos.TransactionInfo;

    String transaction_txnId       = "";
    String transaction_command     = "";
    String transaction_mstatus     = "";
    String transaction_vResultCode = "";
    String transaction_txnDatetime = "";
    String transaction_amount      = "";

    String linepay_linepayErrorCode = "";
    String linepay_detailCommandType = "";
    String linepay_requestDatetime = "";
    String linepay_responseDatetime = "";

    if (transactionInfo != null && 0 < transactionInfo.Length) {
      for (int i = 0; i < transactionInfo.Length; i++) {
        transaction_txnId       = transactionInfo[i].TxnId;       // トランザクション管理ID
        transaction_command     = transactionInfo[i].Command;     // コマンド
        transaction_mstatus     = transactionInfo[i].Mstatus;     // ステータスコード
        transaction_vResultCode = transactionInfo[i].VResultCode; // 結果コード
        transaction_txnDatetime = transactionInfo[i].TxnDatetime; // 取引日時
        transaction_amount      = transactionInfo[i].Amount;      // 金額

        ProperTransactionInfo properTransactionInfo = transactionInfo[i].ProperTransactionInfo;
        if (properTransactionInfo != null) {
          linepay_linepayErrorCode = properTransactionInfo.LinepayErrorCode;        // LINE Pay APIエラーコード
          linepay_detailCommandType = properTransactionInfo.DetailCommandType;      // 詳細コマンドタイプ
          linepay_requestDatetime = properTransactionInfo.LinepayRequestDatetime;   // LINE Payへの要求日時
          linepay_responseDatetime = properTransactionInfo.LinepayResponseDatetime; // LINE Payからの返戻日時
        }
%>
    <tr>
      <!-- 決済トランザクション情報 -->
      <td class="rivalue2" nowrap><%= transaction_txnId %><br/></td>
      <td class="rivalue2" nowrap><%= transaction_command %><br/></td>
      <td class="rivalue2" nowrap><%= transaction_mstatus %><br/></td>
      <td class="rivalue2" nowrap><%= transaction_vResultCode %><br/></td>
      <td class="rivalue2" nowrap><%= transaction_txnDatetime %><br/></td>
      <td class="rivalue2" nowrap><%= transaction_amount %><br/></td>
      <!-- 固有トランザクション情報 -->
      <td class="rivalue2" nowrap><%= linepay_linepayErrorCode%><br/></td>
      <td class="rivalue2" nowrap><%= linepay_detailCommandType%><br/></td>
      <td class="rivalue2" nowrap><%= linepay_requestDatetime%><br/></td>
      <td class="rivalue2" nowrap><%= linepay_responseDatetime%><br/></td>
    </tr>
<%
      }
    }
  }
%>
  </table>    
  <br/>
  <a href="../Search.aspx">検索条件へ戻る</a>&nbsp;&nbsp;

  <hr>
  <img alt="VeriTransロゴ" src="../../WEB-IMG/VeriTransLogo_WH.png"/>&nbsp; Copyright &copy; VeriTrans Inc. All rights reserved
</body>
</html>
