﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="SearchExec.aspx.cs" Inherits="web.search.masterpass.SearchExec" %>
<%@ Import Namespace="jp.veritrans.tercerog.mdk.dto" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <meta http-equiv="Content-Language" content="ja" />
  <title>取引検索結果(MasterPass)</title>
  <link href="../../css/style.css" rel="stylesheet" type="text/css"/>
</head>
<body>
  <img alt="Paymentロゴ" src="../../WEB-IMG/VeriTrans_Payment.png"/><hr/>
  <div class="system-message">
    <font size="2">
    本画面はVeriTrans4G 取引検索のサンプル画面です。<br/>
    お客様ECサイトのショッピングカートとVeriTrans4Gとを連動させるための参考、例としてご利用ください。<br/>
    </font>
  </div>

  <asp:Label ID="errorMessage" runat="server"/>

  <div class="lhtitle">検索結果（MasterPass）</div>
  <h2>オーダー情報</h2>
  <table border="1" cellpadding="0" cellspacing="0">
    <tr bgcolor="#ffeebb">
      <th class="rititle2" nowrap colspan="2">オーダー情報</th>
    </tr>
<%
  if (order_info != null) 
  {
      String target_orderId              = order_info.OrderId;              // オーダーID
      String target_serviceTypeCd        = order_info.ServiceTypeCd;        // 決済サービスタイプ
      String target_orderStatus          = order_info.OrderStatus;          // オーダー決済状態
      String target_lastSuccessTxnType   = order_info.LastSuccessTxnType;   // 最終成功トランザクションタイプ
      String target_successDetailTxnType = order_info.SuccessDetailTxnType; // 詳細トランザクションタイプ
%>
    <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>取引ID</td>
      <td class="rivalue2" nowrap><%= target_orderId %><br/></td>
    </tr>
    <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>決済サービスタイプ</td>
      <td class="rivalue2" nowrap><%= target_serviceTypeCd %><br/></td>
    </tr>
    <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>オーダー決済状態</td>
      <td class="rivalue2" nowrap><%= target_orderStatus %><br/></td>
    </tr>
    <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>最終成功トランザクションタイプ</td>
      <td class="rivalue2" nowrap><%= target_lastSuccessTxnType %><br/></td>
    </tr>
    <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>詳細トランザクションタイプ</td>
      <td class="rivalue2" nowrap><%= target_successDetailTxnType %><br/></td>
    </tr>
    
<% 
  } 
%>   
  </table>
  <br/>
  <table border="1" cellpadding="0" cellspacing="0">
    <tr bgcolor="#ffeebb">
      <th class="rititle2" nowrap colspan="8">固有オーダー情報</th>
    </tr>
<%
    if (order_info != null) {
      ProperOrderInfo properOrderInfo = order_info.ProperOrderInfo;
      String target_withCapture       = properOrderInfo.WithCapture;             // 与信同時売上フラグ
      String target_itemId            = properOrderInfo.ItemId;                  // 商品番号
      String target_itemAmount        = properOrderInfo.ItemAmount;              // 商品金額
      String target_authorizeAmount   = properOrderInfo.AuthorizeAmount;         // 申込金額
      String target_authorizeDatetime = properOrderInfo.AuthorizeDatetime;       // 決済申込日時
      String target_masterpassOrderId = properOrderInfo.MasterpassOrderId;       // MasterPass取引ID
      String target_cardOrderId       = properOrderInfo.CardOrderId;             // カード取引ID
      String target_acquirerCode      = properOrderInfo.AcquirerCode;            // 仕向け先コード
      String target_cardNumber        = properOrderInfo.CardNumber;              // カード番号
%>
   <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>与信同時売上フラグ</td>
      <td class="rivalue2" nowrap width="100"><%= target_withCapture %><br/></td>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>商品番号</td>
      <td class="rivalue2" nowrap width="200"><%= target_itemId %><br/></td>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>商品金額</td>
      <td class="rivalue2" nowrap width="200"><%= target_itemAmount %><br/></td>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>申込金額</td>
      <td class="rivalue2" nowrap><%= target_authorizeAmount %><br/></td>
    </tr>
    <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>決済申込日時</td>
      <td class="rivalue2" nowrap><%= target_authorizeDatetime %><br/></td>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>MasterPass取引ID</td>
      <td class="rivalue2" nowrap width="300"><%= target_masterpassOrderId %><br/></td>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>カード取引ID</td>
      <td class="rivalue2" nowrap><%= target_cardOrderId %><br/></td>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>仕向け先コード</td>
      <td class="rivalue2" nowrap><%= target_acquirerCode %><br/></td>
    </tr>
    <tr>
      <td class="rivalue2" bgcolor="#ffeebb" nowrap>カード番号</td>
      <td class="rivalue2" nowrap><%= target_cardNumber %><br/></td>
    </tr>

<%
  }
%>
  </table>
  <br/>
  <h2>トランザクション情報</h2>
  <table border="1" cellpadding="0" cellspacing="0">
    <tr bgcolor="#ffeebb">
      <th class="rititle2" nowrap colspan="6">決済トランザクション情報</th>
      <th class="rititle2" nowrap colspan="6">固有トランザクション情報</th>
    </tr>
    <tr bgcolor="#ffeebb">
      <!-- 決済トランザクション情報 -->
      <th class="rititle2" nowrap width="65">管理ID</th>
      <th class="rititle2" nowrap width="120">コマンド</th>
      <th class="rititle2" nowrap width="130">ステータスコード</th>
      <th class="rititle2" nowrap width="145">結果コード</th>
      <th class="rititle2" nowrap width="180">取引日時</th>
      <th class="rititle2" nowrap width="100">金額</th>

      <!-- 固有トランザクション情報 -->
      <th class="rititle2" nowrap width="145">承認番号</th>
      <th class="rititle2" nowrap width="145">リファレンス番号</th>
      <th class="rititle2" nowrap width="145">詳細コマンドタイプ</th>
      <th class="rititle2" nowrap width="145">カード結果コード</th>
      <th class="rititle2" nowrap width="170">MasterPassへの要求日時</th>
      <th class="rititle2" nowrap width="185">MasterPassからの返戻日時</th>
    </tr>
<%
  if (order_info != null) {
    TransactionInfos transactionInfos = order_info.TransactionInfos;
    TransactionInfo[] transactionInfo = transactionInfos.TransactionInfo;

    String transaction_txnId       = "";
    String transaction_command     = "";
    String transaction_mstatus     = "";
    String transaction_vResultCode = "";
    String transaction_txnDatetime = "";
    String transaction_amount      = "";

    String masterpass_authCode = "";
    String masterpass_referenceNumber = "";
    String masterpass_detailCommandType = "";
    String masterpass_cardVResultCode = "";
    String masterpass_masterpassRequestDatetime = "";
    String masterpass_masterpassResponseDatetime = "";

    if (transactionInfo != null && 0 < transactionInfo.Length) {
      for (int i = 0; i < transactionInfo.Length; i++) {
        transaction_txnId       = transactionInfo[i].TxnId;       // トランザクション管理ID
        transaction_command     = transactionInfo[i].Command;     // コマンド
        transaction_mstatus     = transactionInfo[i].Mstatus;     // ステータスコード
        transaction_vResultCode = transactionInfo[i].VResultCode; // 結果コード
        transaction_txnDatetime = transactionInfo[i].TxnDatetime; // 取引日時
        transaction_amount      = transactionInfo[i].Amount;      // 金額

        ProperTransactionInfo properTransactionInfo = transactionInfo[i].ProperTransactionInfo;
        if (properTransactionInfo != null) {
            masterpass_authCode                   = properTransactionInfo.AuthCode;                     // 承認番号
            masterpass_referenceNumber            = properTransactionInfo.ReferenceNumber;              // リファレンス番号
            masterpass_detailCommandType          = properTransactionInfo.DetailCommandType;            // 詳細コマンドタイプ
            masterpass_cardVResultCode            = properTransactionInfo.CardVResultCode;              // カード結果コード
            masterpass_masterpassRequestDatetime  = properTransactionInfo.MasterpassRequestDatetime;    // MasterPassへの要求日時
            masterpass_masterpassResponseDatetime = properTransactionInfo.MasterpassResponseDatetime;   // MasterPassからの返戻日時
        }
%>
    <tr>
      <!-- 決済トランザクション情報 -->
      <td class="rivalue2" nowrap><%= transaction_txnId %><br/></td>
      <td class="rivalue2" nowrap><%= transaction_command %><br/></td>
      <td class="rivalue2" nowrap><%= transaction_mstatus %><br/></td>
      <td class="rivalue2" nowrap><%= transaction_vResultCode %><br/></td>
      <td class="rivalue2" nowrap><%= transaction_txnDatetime %><br/></td>
      <td class="rivalue2" nowrap><%= transaction_amount %><br/></td>
      <!-- 固有トランザクション情報 -->
      <td class="rivalue2" nowrap><%= masterpass_authCode %><br/></td>
      <td class="rivalue2" nowrap><%= masterpass_detailCommandType %><br/></td>
      <td class="rivalue2" nowrap><%= masterpass_cardVResultCode %><br/></td>
      <td class="rivalue2" nowrap><%= masterpass_cardVResultCode %><br/></td>
      <td class="rivalue2" nowrap><%= masterpass_masterpassRequestDatetime %><br/></td>
      <td class="rivalue2" nowrap><%= masterpass_masterpassResponseDatetime %><br/></td>
    </tr>
<%
      }
    }
  }
%>
  </table>    
  <br/>
  <a href="../Search.aspx">検索条件へ戻る</a>&nbsp;&nbsp;

  <hr>
  <img alt="VeriTransロゴ" src="../../WEB-IMG/VeriTransLogo_WH.png"/>&nbsp; Copyright &copy; VeriTrans Inc. All rights reserved
</body>
</html>
