﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;
using MdkSampleDotNet;

namespace web.virtualacc
{
    public partial class Authorize : System.Web.UI.Page
    {
        /// <summary>
        /// 初期表示イベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                orderId.Text = "dummy" + Utils.CurrentTimeMillis();
                amount.Text = Request.QueryString["price"];
                entryTransferName.Text = Request.QueryString["entryTransferName"];
                entryTransferNumber.Text = Request.QueryString["entryTransferNumber"];
                transferExpiredDate.Text = Request.QueryString["transferExpiredDate"];
                branchCode.Text = Request.QueryString["branchCode"];
                accountNumber.Text = Request.QueryString["accountNumber"];
                
                accountManageType.Items.Add(new ListItem("実口座", MdkServiceConstants.VACC_ACCOUNT_MANAGE_TYPE_REAL));
                accountManageType.Items.Add(new ListItem("バーチャル口座", MdkServiceConstants.VACC_ACCOUNT_MANAGE_TYPE_VIRTUAL));

                if (MdkServiceConstants.VACC_ACCOUNT_MANAGE_TYPE_REAL == Request.QueryString["accountManageType"])
                {
                    ListItem selectItem = accountManageType.Items.FindByValue(MdkServiceConstants.VACC_ACCOUNT_MANAGE_TYPE_REAL);
                    selectItem.Selected = true;
                }
                else if (MdkServiceConstants.VACC_ACCOUNT_MANAGE_TYPE_VIRTUAL == Request.QueryString["accountManageType"])
                {
                    ListItem selectItem = accountManageType.Items.FindByValue(MdkServiceConstants.VACC_ACCOUNT_MANAGE_TYPE_VIRTUAL);
                    selectItem.Selected = true;
                }
            }
        }

        /// <summary>
        /// 取引ID更新ボタンイベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnReplaceOrderId_Click(object sender, EventArgs e)
        {
            orderId.Text = "dummy" + Utils.CurrentTimeMillis();
        }

        /// <summary>
        /// 購入ボタンイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 取引IDの取得
            String paramOrderId = orderId.Text;
            // 金額の取得
            String paramAmount = amount.Text;

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 入力をチェックします。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            if (String.IsNullOrEmpty(paramOrderId))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramAmount))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font><br/><br/>";
                return;
            }

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 画面入力値を実行クラスに渡すためにセッションに設定します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Session["paramOrderId"] = paramOrderId;
            Session["paramAmount"] = paramAmount;
            Session["entryTransferName"] = entryTransferName.Text;
            Session["entryTransferNumber"] = entryTransferNumber.Text;
            Session["transferExpiredDate"] = transferExpiredDate.Text;
            Session["accountManageType"] = accountManageType.SelectedValue;
            Session["branchCode"] = branchCode.Text;
            Session["accountNumber"] = accountNumber.Text;

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 実行＆結果画面を表示します
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Response.Redirect("./AuthorizeExec.aspx", true);
        }
    }
}