﻿using jp.veritrans.tercerog.mdk.dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace web.virtualacc
{
    public partial class DepositEntry : System.Web.UI.Page
    {
        /// <summary>
        /// 初期表示イベント。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                withReconcile.Items.Add(new ListItem(""));
                withReconcile.Items.Add(new ListItem("消込しない", MdkServiceConstants.VACC_WITH_RECONCILE_NOT));
                withReconcile.Items.Add(new ListItem("消込(強制)", MdkServiceConstants.VACC_WITH_RECONCILE_FORCE));
                withReconcile.Items.Add(new ListItem("消込(自動)", MdkServiceConstants.VACC_WITH_RECONCILE_AUTO));

                registrationMethod.Items.Add(new ListItem(""));
                registrationMethod.Items.Add(new ListItem("手動", MdkServiceConstants.VACC_REGISTRATION_METHOD_MANUAL));
                registrationMethod.Items.Add(new ListItem("自動", MdkServiceConstants.VACC_REGISTRATION_METHOD_AUTO));
            }
        }

        /// <summary>
        /// 入金ボタンイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 取引IDの取得
            String paramOrderId = orderId.Text;
            // 金額の取得
            String paramAmount = amount.Text;

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 入力をチェックします。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            if (String.IsNullOrEmpty(paramOrderId))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：取引IDが指定されていません</b></font><br/><br/>";
                return;
            }
            if (String.IsNullOrEmpty(paramAmount))
            {
                errorMessage.Text = "<font color='#ff0000'><b>必須項目：金額が指定されていません</b></font><br/><br/>";
                return;
            }

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 画面入力値を実行クラスに渡すためにセッションに設定します。
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Session["paramOrderId"] = paramOrderId;
            Session["paramAmount"] = paramAmount;
            Session["transferName"] = transferName.Text;
            Session["withReconcile"] = withReconcile.SelectedValue;
            Session["registrationMethod"] = registrationMethod.SelectedValue;
            Session["depositDate"] = depositDate.Text;

            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 実行＆結果画面を表示します
            // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            Response.Redirect("./DepositEntryExec.aspx", true);
        }
    }
}