﻿using jp.veritrans.tercerog.mdk;
using jp.veritrans.tercerog.mdk.dto;
using System;

namespace web.virtualacc
{
    public partial class DepositReverseExec : System.Web.UI.Page
    {
        /// <summary>
        /// 初期表示イベント。
        /// パラメータを元に、GWと通信を行う。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            Response.Charset = "UTF-8";

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // パラメータを取得します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            String paramOrderId = (String)Session["paramOrderId"];
            String paramDepositId = (String)Session["depositId"];

            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            // 要求DTOを生成し、値を設定します。
            // +++++++++++++++++++++++++++++++++++++++++++++++++++++
            VirtualaccDepositReverseRequestDto requestData = new VirtualaccDepositReverseRequestDto();
            requestData.OrderId = paramOrderId;
            requestData.DepositId = paramDepositId;
            requestData.ServiceOptionType = MdkServiceConstants.VACC_RESONA;
            try
            {
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // コマンドを実行し、応答DTOを取得します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                Transaction tran = new Transaction();
                VirtualaccDepositReverseResponseDto responseData = (VirtualaccDepositReverseResponseDto)tran.Execute(requestData);

                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                // 結果画面に表示します。
                // +++++++++++++++++++++++++++++++++++++++++++++++++++++
                OrderId.Text = responseData.OrderId;
                Mstatus.Text = responseData.Mstatus;
                VResultCode.Text = responseData.VResultCode;
                MerrMsg.Text = responseData.MerrMsg;
                TotalDepositAmount.Text = responseData.TotalDepositAmount;
            }
            catch (Exception ex)
            {
                Console.WriteLine("Exception Occured !");
                Console.WriteLine("Exception Message: " + ex.Message);
                MerrMsg.Text = "Exception Occured : " + ex.Message;
            }
            Session.Clear();
        }
    }
}